//! \file
//!
//! Integer (signed/unsigned) typedefs.
//--------------------------------------------------------------------------
// Copyright 2003, Cypress Semiconductor Corporation
//
// This software is owned by Cypress Semiconductor Corporation (Cypress) and
// is protected by United States copyright laws and international treaty
// provisions.  Therefore, unless otherwise specified in a separate license
// agreement, you must treat this software like any other copyrighted
// material.  Reproduction, modification, translation, compilation, or
// representation of this software in any other form (e.g., paper,
// magnetic, optical, silicon, etc.) is prohibited without the express
// written permission of Cypress.
//
// Disclaimer: Cypress makes no warranty of any kind, express or implied,
// with regard to this material, including, but not limited to, the
// implied warranties of merchantability and fitness for a particular
// purpose. Cypress reserves the right to make changes without further
// notice to the materials described herein. Cypress does not assume any
// liability arising out of the application or use of any product or circuit
// described herein. Cypress' products described herein are not authorized
// for use as components in life-support devices.
//
// This software is protected by and subject to worldwide patent coverage,
// including U.S. and foreign patents. Use may be limited by and subject to
// the Cypress Software License Agreement.
//
//--------------------------------------------------------------------------

#ifndef CYPDEF_H
#define CYPDEF_H

//--------------------------------------
// Included files
//--------------------------------------

#include "m8c.h"


//--------------------------------------
// API Definitions and Types
//--------------------------------------

#ifndef NULL
//! In case you want to use 'NULL'
#define NULL            0x00
#endif

//! Type for any 8 bit unsigned integer
typedef unsigned char   UINT8;
//! Type for any 16 bit unsigned integer
typedef unsigned short  UINT16;
//! Type for any 32 bit unsigned integer
typedef unsigned long   UINT32;

//! Type for any 8 bit signed integer
typedef signed char     INT8;
//! Type for any 16 bit integer
typedef short int       INT16;
//! Type for any 32 bit integer
typedef long  int       INT32;

#endif   // CYPDEF_H


