	.module keypad.c
	.area lit(rom, con, rel)
_keyScan:
	.word 95
	.word 92
	.word 89
	.word 98
	.word 96
	.word 93
	.word 90
	.word 99
	.word 97
	.word 94
	.word 91
	.word 76
	.word 77
	.word 86
	.word 87
	.word 88
	.word 74
	.word 83
	.word 84
	.word 85
	.dbfile ./keypad.c
	.dbsym s keyScan _keyScan A[40:20]s
	.area text(rom, con, rel)
	.dbfile ./keypad.c
	.dbfunc s keyQueueInit _keyQueueInit fV
_keyQueueInit:
	.dbline -1
	.dbline 139
; //--------------------------------------------------------------------------
; //! \file
; //!
; //!  Keypad application function collection 
; //!
; //--------------------------------------------------------------------------
; // $Archive: /WirelessUSB/LS/Firmware/LS DVK/PSoC/DVK Keypad/keypad.c $
; // $Modtime: 3/04/04 3:11p $
; // $Revision: 1.5 $
; //--------------------------------------------------------------------------
; //
; // Copyright 2003, Cypress Semiconductor Corporation.
; //
; // This software is owned by Cypress Semiconductor Corporation (Cypress)
; // and is protected by and subject to worldwide patent protection (United
; // States and foreign), United States copyright laws and international 
; // treaty provisions. Cypress hereby grants to licensee a personal, 
; // non-exclusive, non-transferable license to copy, use, modify, create 
; // derivative works of, and compile the Cypress Source Code and derivative 
; // works for the sole purpose of creating custom software in support of 
; // licensee product to be used only in conjunction with a Cypress integrated 
; // circuit as specified in the applicable agreement. Any reproduction, 
; // modification, translation, compilation, or representation of this 
; // software except as specified above is prohibited without the express 
; // written permission of Cypress.
; //
; // Disclaimer: CYPRESS MAKES NO WARRANTY OF ANY KIND,EXPRESS OR IMPLIED, 
; // WITH REGARD TO THIS MATERIAL, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
; // WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
; // Cypress reserves the right to make changes without further notice to the
; // materials described herein. Cypress does not assume any liability arising
; // out of the application or use of any product or circuit described herein.
; // Cypress does not authorize its products for use as critical components in
; // life-support systems where a malfunction or failure may reasonably be
; // expected to result in significant injury to the user. The inclusion of
; // Cypress product in a life-support systems application implies that the
; // manufacturer assumes all risk of such use and in doing so indemnifies
; // Cypress against all charges.
; //
; // Use may be limited by and subject to the applicable Cypress software
; // license agreement.
; //
; //--------------------------------------------------------------------------
; 
; //--------------------------------------
; // Included files
; //--------------------------------------
; 
; #include "keypad.h"
; #include "pdc9075.h"
; 
; 
; //--------------------------------------
; // Local Definitions and Types
; //--------------------------------------
; //! 0x5F corresponds to button 7 on keypad
; //!
; //! 0x5C corresponds to button 4 on keypad
; //!
; //! 0x59 corresponds to button 1 on keypad
; //!
; //! 0x62 corresponds to button 0 on keypad
; //!
; //! 0x60 corresponds to button 8 on keypad
; //!
; //! 0x5D corresponds to button 5 on keypad
; //!
; //! 0x5A corresponds to button 2 on keypad
; //!
; //! 0x63 corresponds to button . on keypad
; //!
; //! 0x61 corresponds to button 9 on keypad
; //!
; //! 0x5E corresponds to button 6 on keypad
; //!
; //! 0x5B corresponds to button 3 on keypad
; //!
; //! 0x4C corresponds to button Spare (delete)
; //!
; //! 0x4D corresponds to right joystick (end)
; //!
; //! 0x56 corresponds to button - on keypad
; //!
; //! 0x57 corresponds to button + on keypad
; //!
; //! 0x58 corresponds to button Enter on keypad
; //!
; //! 0x4A corresponds to button left joystick (home)
; //!
; //! 0x53 corresponds to button num lock on keypad
; //!
; //! 0x54 corresponds to button / on keypad
; //!
; //! 0x55 corresponds to button * on keypad
; static const UINT16 keyScan[] = {
;     0x5F,           // 0,0  keypad 7    
;     0x5C,           // 0,1  keypad 4
;     0x59,           // 0,2  keypad 1
;     0x62,           // 0,3  keypad 0
;     0x60,           // 1,0  keypad 8
;     0x5D,           // 1,1  keypad 5
;     0x5A,           // 1,2  keypad 2
;     0x63,           // 1,3  keypad .
;     0x61,           // 2,0  keypad 9
;     0x5E,           // 2,1  keypad 6
;     0x5B,           // 2,2  keypad 3
;     0x4C,           // 2,3  spare (delete)
;     0x4D,           // 3,0  right thumb switch (end)
;     0x56,           // 3,1  keypad -
;     0x57,           // 3,2  keypad +
;     0x58,           // 3,3  keypad Enter
;     0x4A,           // 4,0  left thumb switch (home)
;     0x53,           // 4,1  num lock
;     0x54,           // 4,2  keypad /
;     0x55            // 4,3  keypad *
; };
; 
; //! Key array to keep track of current state
; UINT8 keyState[COLUMNS + 1];
; 
; //! Key queue to buffer key presses
; KEY_FIFO    keyQueue;
; 
; 
; 
; ///////////////////////////////////////////////////////////////////////////////
; //
; //  Function:    keyQueueInit
; //
; //!  Description: Initialize the keypad activity queue
; //!
; //!  Inputs:      Void
; //!
; //!  Returns:     Void
; //!
; ///////////////////////////////////////////////////////////////////////////////
; 
; static void keyQueueInit()
; {
	.dbline 140
;     keyQueue.in = 0;
	mov [_keyQueue],0
	.dbline 141
;     keyQueue.out = 0;
	mov [_keyQueue+1],0
	.dbline 142
;     keyQueue.count = 0;
	mov [_keyQueue+2],0
	.dbline -2
	.dbline 143
; }
L1:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc s putKeyQueue _putKeyQueue fc
;          index -> X-5
;          state -> X-4
_putKeyQueue:
	.dbline -1
	push X
	mov X,SP
	.dbline 164
; 
; 
; ///////////////////////////////////////////////////////////////////////////////
; //
; //  Function:    putKeyQueue
; //
; //!  Description: Add a keypad button event to the keypad queue if there 
; //!               is room and update keyqueue parameters where needed.
; //!
; //!  Inputs:      
; //!               - state - the state the key being added is in              
; //!               - index - index of key
; //!
; //!  Returns:     
; //!               - 0 - no room              
; //!               - 1 - state added
; //!
; ///////////////////////////////////////////////////////////////////////////////
; 
; static UINT8 putKeyQueue(KEY_STATE state, UINT8 index)
; {
	.dbline 165
;     if(keyQueue.count == KEY_QUEUE_LEN)
	cmp [_keyQueue+2],8
	jnz L5
	.dbline 166
;     {
	.dbline 167
;         return(0);
	mov A,0
	xjmp L4
L5:
	.dbline 170
;     }
;     
;     keyQueue.count++;
	inc [_keyQueue+2]
	.dbline 172
; 
;     keyQueue.key[keyQueue.in].index = index;
	mov [__r1],[_keyQueue]
	mov [__r0],0
	asl [__r1]
	rlc [__r0]
	add [__r1],<_keyQueue+3+1
	adc [__r0],>_keyQueue+3+1
	mov A,[X-5]
	mvi [__r1],A
	.dbline 173
;     keyQueue.key[keyQueue.in].state = state;
	mov [__r1],[_keyQueue]
	mov [__r0],0
	asl [__r1]
	rlc [__r0]
	add [__r1],<_keyQueue+3
	adc [__r0],>_keyQueue+3
	mov A,[X-4]
	mvi [__r1],A
	.dbline 175
; 
;     keyQueue.in++;
	inc [_keyQueue]
	.dbline 176
;     if(keyQueue.in == KEY_QUEUE_LEN)
	cmp [_keyQueue],8
	jnz L12
	.dbline 177
;     {
	.dbline 178
;         keyQueue.in = 0;
	mov [_keyQueue],0
	.dbline 179
;     }
L12:
	.dbline 180
;     return(1); 
	mov A,1
	.dbline -2
L4:
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l index -5 c
	.dbsym l state -4 c
	.dbend
	.dbfunc s getKeyQueue _getKeyQueue fc
;          index -> X-7
;          state -> X-5
_getKeyQueue:
	.dbline -1
	push X
	mov X,SP
	.dbline 201
; }
; 
; ///////////////////////////////////////////////////////////////////////////////
; //
; //  Function:    getKeyQueue
; //
; //!  Description: Get a keypad button event from the keypad queue and update
; //!               keyqueue parameters as needed
; //!
; //!  Inputs:      
; //!               - *state - state the key being dequeued is in
; //!               - *index - key index
; //!
; //!  Returns:     
; //!               - 0 = no entries
; //!               - 1 = state returned
; //!
; ///////////////////////////////////////////////////////////////////////////////
; 
; static UINT8 getKeyQueue(KEY_STATE *state, UINT8 *index)
; {
	.dbline 202
;     if(keyQueue.count == 0)
	cmp [_keyQueue+2],0
	jnz L15
	.dbline 203
;     {
	.dbline 204
;         return(0);
	mov A,0
	xjmp L14
L15:
	.dbline 207
;     }
;     
;     keyQueue.count--;
	dec [_keyQueue+2]
	.dbline 209
;     
;     *index = keyQueue.key[keyQueue.out].index;
	mov [__r1],[_keyQueue+1]
	mov [__r0],0
	asl [__r1]
	rlc [__r0]
	add [__r1],<_keyQueue+3+1
	adc [__r0],>_keyQueue+3+1
	mvi A,[__r1]
	mov [__r0],A
	mov A,[X-6]
	mov [__r3],A
	mov A,[__r0]
	mvi [__r3],A
	.dbline 210
;     *state = keyQueue.key[keyQueue.out].state;
	mov [__r1],[_keyQueue+1]
	mov [__r0],0
	asl [__r1]
	rlc [__r0]
	add [__r1],<_keyQueue+3
	adc [__r0],>_keyQueue+3
	mvi A,[__r1]
	mov [__r0],A
	mov A,[X-4]
	mov [__r3],A
	mov A,[__r0]
	mvi [__r3],A
	.dbline 212
; 
;     keyQueue.out++;
	inc [_keyQueue+1]
	.dbline 213
;     if(keyQueue.out == KEY_QUEUE_LEN)
	cmp [_keyQueue+1],8
	jnz L25
	.dbline 214
;     {
	.dbline 215
;         keyQueue.out = 0;
	mov [_keyQueue+1],0
	.dbline 216
;     }
L25:
	.dbline 217
;     return(1); 
	mov A,1
	.dbline -2
L14:
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l index -7 pc
	.dbsym l state -5 pc
	.dbend
	.dbfunc e app_init _app_init fV
;              i -> X+0
_app_init::
	.dbline -1
	push X
	mov X,SP
	add SP,1
	.dbline 233
; }
; 
; ///////////////////////////////////////////////////////////////////////////////
; //
; //  Function:    app_init
; //
; //!  Description: Initialize the keypad queue and stated for each key
; //!
; //!  Inputs:      Void
; //!
; //!  Returns:     Void
; //!
; ///////////////////////////////////////////////////////////////////////////////
; 
; void app_init()
; {
	.dbline 236
;     UINT8 i;
; 
;     keyQueueInit();
	xcall _keyQueueInit
	.dbline 238
; 
;     for(i = 0; i < COLUMNS; ++i)
	mov [X+0],0
	xjmp L33
L30:
	.dbline 239
	.dbline 240
	mov A,[X+0]
	mov [__r1],A
	mov [__r0],0
	add [__r1],<_keyState
	adc [__r0],>_keyState
	mov A,-1
	mvi [__r1],A
	.dbline 241
L31:
	.dbline 238
	inc [X+0]
L33:
	.dbline 238
	cmp [X+0],5
	jc L30
X0:
	.dbline -2
	.dbline 242
;     {
;         keyState[i] = 0xFF;
;     }
; }
L29:
	add SP,-1
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l i 0 c
	.dbend
	.dbfunc e scan_keys _scan_keys fV
;          index -> X+7
; column_port_shadow -> X+6
;            row -> X+5
;         rowBit -> X+4
;            col -> X+3
;            key -> X+1
;           mask -> X+0
_scan_keys::
	.dbline -1
	push X
	mov X,SP
	add SP,8
	.dbline 260
; 
; ///////////////////////////////////////////////////////////////////////////////
; //
; //  Function:    scan_keys
; //
; //!  Description: Scan the keypad ports for activity via each column/
; //!               row combination, adds the key to the queue and sets the key 
; //!               state dependent upon which keys are held down.  Then restores
; //!               the port used by the column
; //!
; //!  Inputs:      Void
; //!
; //!  Returns:     Void
; //!
; ///////////////////////////////////////////////////////////////////////////////
; 
; void scan_keys()
; {
	.dbline 268
;     UINT8 col, row;
;     UINT8 mask, rowBit;
;     UINT8 index;
;     UINT8 column_port_shadow;
;     KEY key;
; 
;     // save port 4 setup
;     column_port_shadow = COL_PORT_DR;
	mov A,REG[0xc]
	mov [X+6],A
	.dbline 271
; 
;     // loop through the keypad columns
;     for(col = 0; col < COLUMNS; ++col)
	mov [X+3],0
	xjmp L38
L35:
	.dbline 272
;     {
	.dbline 274
;         // drive the column
;         COL_PORT_DR = ~(0x01 << col);
	mov [__r0],1
	mov A,[X+3]
	and A,7
	jz X1
X2:
	asl [__r0]
	dec A
	jnz X2
X1:
	mov A,[__r0]
	cpl A
	mov REG[0xc],A
	.dbline 276
;         // read the row
;         row = PRT5DR;
	mov A,REG[0x14]
	mov [X+5],A
	.dbline 277
;         row &= (ROW_0 | ROW_1 | ROW_2 | ROW_3);
	and [X+5],15
	.dbline 280
;         
;                 // loop through the keypad row
;         mask = 0x01;
	mov [X+0],1
	.dbline 281
;         for(mask = 0x01, rowBit = 0;rowBit < ROWS; ++rowBit, mask <<= 1)
	mov [X+0],1
	mov [X+4],0
	xjmp L42
L39:
	.dbline 282
;         {
	.dbline 283
;             if((row & mask) == (keyState[col] & mask))
	mov A,[X+3]
	mov [__r1],A
	mov [__r0],0
	add [__r1],<_keyState
	adc [__r0],>_keyState
	mvi A,[__r1]
	mov [__r0],A
	mov A,[X+0]
	and [__r0],A
	mov A,[X+5]
	and A,[X+0]
	cmp A,[__r0]
	jnz L43
	.dbline 284
;             {
	.dbline 285
;                 continue;   // No change
	xjmp L40
L43:
	.dbline 288
;             }
;             
;             if(!(row & mask))   // down key
	mov A,[X+5]
	and A,[X+0]
	jnz L45
	.dbline 289
;             {
	.dbline 290
;                 key.state = KEY_STATE_DOWN;
	mov [X+1],0
	.dbline 291
;             }
	xjmp L46
L45:
	.dbline 293
;             else                // upkey
;             {
	.dbline 294
;                 key.state = KEY_STATE_UP;
	mov [X+1],1
	.dbline 295
;             }
L46:
	.dbline 297
;             
;             key.index = (col * ROWS) + rowBit;
	mov A,[X+3]
	asl A
	asl A
	add A,[X+4]
	mov [X+2],A
	.dbline 299
;             
;             if(!putKeyQueue(key.state, key.index))
	mov A,[X+2]
	push A
	mov A,[X+1]
	push A
	xcall _putKeyQueue
	add SP,-2
	cmp A,0
	jnz L48
	.dbline 300
;             {
	.dbline 301
;                 continue;
	xjmp L40
L48:
	.dbline 305
;             }
;             
;             // update state if everything okay          
;             if(key.state == KEY_STATE_DOWN)
	cmp [X+1],0
	jnz L51
	.dbline 306
;             {
	.dbline 307
;                  keyState[col] &= ~mask;
	mov A,[X+3]
	mov [__r1],A
	mov [__r0],0
	add [__r1],<_keyState
	adc [__r0],>_keyState
	mov A,[X+0]
	cpl A
	mov [__r2],A
	mvi A,[__r1]
	dec [__r1]
	and A,[__r2]
	mvi [__r1],A
	.dbline 308
;             }
	xjmp L52
L51:
	.dbline 310
;             else
;             {
	.dbline 311
;                   keyState[col] |= mask;        
	mov A,[X+3]
	mov [__r1],A
	mov [__r0],0
	add [__r1],<_keyState
	adc [__r0],>_keyState
	mvi A,[__r1]
	dec [__r1]
	mov [__r2],A
	mov A,[X+0]
	or [__r2],A
	mov A,[__r2]
	mvi [__r1],A
	.dbline 312
;             }
L52:
	.dbline 313
L40:
	.dbline 281
	inc [X+4]
	asl [X+0]
L42:
	.dbline 281
	cmp [X+4],4
	jc L39
X3:
	.dbline 314
L36:
	.dbline 271
	inc [X+3]
L38:
	.dbline 271
	cmp [X+3],5
	jc L35
X4:
	.dbline 316
;         }
;     }
;     // restore port 4 setup
;     COL_PORT_DR = column_port_shadow;
	mov A,[X+6]
	mov REG[0xc],A
	.dbline -2
	.dbline 317
; }
L34:
	add SP,-8
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l index 7 c
	.dbsym l column_port_shadow 6 c
	.dbsym l row 5 c
	.dbsym l rowBit 4 c
	.dbsym l col 3 c
	.dbsym l key 1 X
	.dbsym l mask 0 c
	.dbend
	.dbfunc e app_tx_process _app_tx_process fc
;          index -> X+2
;          state -> X+1
;              i -> X+0
;         report -> X-5
_app_tx_process::
	.dbline -1
	push X
	mov X,SP
	add SP,3
	.dbline 338
; 
; ///////////////////////////////////////////////////////////////////////////////
; //
; //  Function:    app_tx_process
; //
; //!  Description: Process the keypad activity report by scanning the keys for
; //!               any activity, and generates the transmit report packet by 
; //!               setting the packet parameters (key, state, etc.)
; //!
; //!  Inputs:      
; //!               - *report - report transmit packet to store any activity to
; //!               transmit 
; //!
; //!  Returns:     
; //!               - 0 = no activity
; //!               - 1 = report to send
; //!
; ///////////////////////////////////////////////////////////////////////////////
; 
; UINT8 app_tx_process(APP_TX_PACKET *report)
; {
	.dbline 344
;     UINT8     i;
;     KEY_STATE state;
;     UINT8     index;
; 
;     // check for keypad events
;     scan_keys();
	xcall _scan_keys
	.dbline 346
; 
;     if(keyQueue.count == 0)
	cmp [_keyQueue+2],0
	jnz L54
	.dbline 347
;     {
	.dbline 348
;         return(0);
	mov A,0
	xjmp L53
L54:
	.dbline 350
;     }
;     report->modifiers = 0;
	mov A,[X-4]
	mov [__r1],A
	mov A,0
	mvi [__r1],A
	.dbline 351
;     report->reserved = 0;
	mov A,[X-4]
	add A,1
	mov [__r1],A
	mov A,0
	mvi [__r1],A
	.dbline 353
; 
;     for(i = 0; i < REPORT_KEYCODES; ++i)
	mov [X+0],0
	xjmp L60
L57:
	.dbline 354
	.dbline 355
	mov A,[X-4]
	add A,2
	mov [__r1],A
	mov A,[X+0]
	add A,[__r1]
	mov [__r1],A
	mov A,0
	mvi [__r1],A
	.dbline 356
L58:
	.dbline 353
	inc [X+0]
L60:
	.dbline 353
	cmp [X+0],1
	jc L57
X5:
	.dbline 358
;     {
;         report->keyCode[i] = 0; 
;     }
; 
;     i = 0;
	mov [X+0],0
	xjmp L62
L61:
	.dbline 360
;     while(getKeyQueue(&state, &index))
;     {
	.dbline 361
;         if(state == KEY_STATE_DOWN)
	cmp [X+1],0
	jnz L64
	.dbline 362
;         {
	.dbline 363
;             report->keyCode[i++] = keyScan[index];          
	mov A,[X+0]
	mov [__r1],A
	mov [__r0],0
	add A,1
	mov [X+0],A
	mov A,[X+2]
	mov [__r3],A
	mov [__r2],0
	asl [__r3]
	rlc [__r2]
	add [__r3],<_keyScan
	adc [__r2],>_keyScan
	mov A,[__r2]
	push X
	push A
	mov X,[__r3]
	romx
	pop A
	inc X
	adc A,0
	romx
	pop X
	mov [__r2],A
	mov A,[X-4]
	add A,2
	mov [__r5],A
	mov A,[X-5]
	adc A,0
	mov [__r4],A
	mov A,[__r5]
	add [__r1],A
	mov A,[__r4]
	adc [__r0],A
	mov A,[__r2]
	mvi [__r1],A
	.dbline 364
;         }   
L64:
	.dbline 365
L62:
	.dbline 359
	mov [__r1],X
	add [__r1],2
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	mov [__r1],X
	add [__r1],1
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	xcall _getKeyQueue
	add SP,-4
	cmp A,0
	jnz L61
	.dbline 367
;     }
;     
;     return(1);
	mov A,1
	.dbline -2
L53:
	add SP,-3
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l index 2 c
	.dbsym l state 1 c
	.dbsym l i 0 c
	.dbsym l report -5 pX
	.dbend
	.area bss(ram, con, rel)
	.dbfile ./keypad.c
_keyQueue::
	.blkb 19
	.dbsym e keyQueue _keyQueue X
_keyState::
	.blkb 6
	.dbsym e keyState _keyState A[6:6]c
