	.module main.c
	.area text(rom, con, rel)
	.dbfile ./main.c
	.dbfunc e main _main fV
;            col -> X+9
; column_port_shadow -> X+8
;            row -> X+7
;    bind_status -> X+6
;         tx_pkt -> X+4
;         status -> X+3
;             ts -> X+1
;           mode -> X+0
_main::
	.dbline -1
	push X
	mov X,SP
	add SP,10
	.dbline 73
; //--------------------------------------------------------------------------
; //! \file
; //!
; //!  Main DVK Keypad application routine
; //!
; //--------------------------------------------------------------------------
; // $Archive: /WirelessUSB/LS/Firmware/LS DVK/PSoC/DVK Keypad/main.c $
; // $Modtime: 3/16/04 9:52a $
; // $Revision: 1.5 $
; //--------------------------------------------------------------------------
; //
; // Copyright 2003, Cypress Semiconductor Corporation.
; //
; // This software is owned by Cypress Semiconductor Corporation (Cypress)
; // and is protected by and subject to worldwide patent protection (United
; // States and foreign), United States copyright laws and international 
; // treaty provisions. Cypress hereby grants to licensee a personal, 
; // non-exclusive, non-transferable license to copy, use, modify, create 
; // derivative works of, and compile the Cypress Source Code and derivative 
; // works for the sole purpose of creating custom software in support of 
; // licensee product to be used only in conjunction with a Cypress integrated 
; // circuit as specified in the applicable agreement. Any reproduction, 
; // modification, translation, compilation, or representation of this 
; // software except as specified above is prohibited without the express 
; // written permission of Cypress.
; //
; // Disclaimer: CYPRESS MAKES NO WARRANTY OF ANY KIND,EXPRESS OR IMPLIED, 
; // WITH REGARD TO THIS MATERIAL, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
; // WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
; // Cypress reserves the right to make changes without further notice to the
; // materials described herein. Cypress does not assume any liability arising
; // out of the application or use of any product or circuit described herein.
; // Cypress does not authorize its products for use as critical components in
; // life-support systems where a malfunction or failure may reasonably be
; // expected to result in significant injury to the user. The inclusion of
; // Cypress product in a life-support systems application implies that the
; // manufacturer assumes all risk of such use and in doing so indemnifies
; // Cypress against all charges.
; //
; // Use may be limited by and subject to the applicable Cypress software
; // license agreement.
; //--------------------------------------------------------------------------
; 
; //--------------------------------------
; // Included files
; //--------------------------------------
; 
; #include "protocol.h"
; #include "keypad.h"
; #include "bind.h"
; #include "mfgtest.h"
; 
; ///////////////////////////////////////////////////////////////////////////////
; //
; //  Function:    main
; //
; //!  Description: Keypad main function initializes the interrupt service
; //!               routine, timer, platform board, protocol, and keypad. Then 
; //!               gets the transmit packet pointer.  Runs the manufacturing
; //!               tests (if USE_MFG_TEST is defined).  Then it 
; //!               continuously gets a time stamp and checks for activity.  If
; //!               there is activity, it will transfer a packet and turn on 
; //!               the connect LED, if it is valid data.  If it isn't valid data 
; //!               the connect LED will shut off.  If there is no activity, it
; //!               will look for a bind button press and bind if necessary.
; //!
; //!  Inputs:      Void
; //!
; //!  Returns:     Void
; //!
; ///////////////////////////////////////////////////////////////////////////////
; void main()
; {
	.dbline 82
;     APP_TX_PACKET *tx_pkt;
;     UINT8          mode;
;     UINT8          status;
;     UINT8          bind_status;
;     TIME_STAMP     ts;
;     #ifdef USE_MFG_TEST
;     UINT8          row;
;     UINT8          column_port_shadow;
;     UINT8          col = 0x02;
	mov [X+9],2
	.dbline 87
;     #endif //USE_MFG_TEST
; 
;     // initialize the system
;     // setup the GPIO interrupt logic
;     isr_init();
	xcall _isr_init
	.dbline 90
; 
;     // initialize the timer and its ISR
;     timer_init();
	xcall _timer_init
	.dbline 93
; 
;     // configure the board
;     platform_init();
	xcall _platform_init
	.dbline 96
; 
;     // setup and configure the radio and protocol
;     protocol_init();
	xcall _protocol_init
	.dbline 98
; 
;     app_init();
	xcall _app_init
	.dbline 101
;     
;     // get the packet pointers
;     tx_pkt = protocol_get_tx_pkt();
	xcall _protocol_get_tx_pkt
	mov A,[__r1]
	mov [X+5],A
	mov A,[__r0]
	mov [X+4],A
	.dbline 105
;     
;     #ifdef USE_MFG_TEST
;     // using BUTTON_SPARE which is row 3 column 2
;     column_port_shadow = COL_PORT_DR;
	mov A,REG[0xc]
	mov [X+8],A
	.dbline 107
;     // drive the column
;     COL_PORT_DR = ~(0x01 << col); //0x01 << col = 0100 (Column 2)
	mov [__r0],1
	mov A,[X+9]
	and A,7
	jz X1
X2:
	asl [__r0]
	dec A
	jnz X2
X1:
	mov A,[__r0]
	cpl A
	mov REG[0xc],A
	.dbline 109
;     // read the row
;     row = PRT5DR & ROW_3;
	mov A,REG[0x14]
	and A,8
	mov [X+7],A
	.dbline 110
;     COL_PORT_DR = column_port_shadow;
	mov A,[X+8]
	mov REG[0xc],A
	.dbline 111
;     if(!(row & 0x08)) // down key -> !(row & mask)  ROW_3 is defined as 8
	tst [X+7],8
	jnz L29
	.dbline 113
;                       //mask = 1b for ROW_0, 10b for ROW_1 ... 1000b for ROW_3
;     {
	.dbline 114
;         MFG_TEST();
	xcall _mfg_test
	.dbline 115
;     }
	xjmp L29
L28:
	.dbline 120
;     #endif //USE_MFG_TEST
; 
;     // main infinite control loop
;     while(1) 
;     {   
	.dbline 121
;         ts = TIMER_GET_TIME_STAMP();
	xcall _timer_get_time_stamp
	mov A,[__r1]
	mov [X+2],A
	mov A,[__r0]
	mov [X+1],A
	.dbline 124
;         
;         // perform keypad routine 
;         mode = app_tx_process( tx_pkt );  
	mov A,[X+4]
	push A
	mov A,[X+5]
	push A
	xcall _app_tx_process
	add SP,-2
	mov [X+0],A
	.dbline 127
;         
;         // send packet if needed   
;         if( mode != NO_ACTIVITY )
	cmp [X+0],0
	jz L31
	.dbline 128
;         {
	.dbline 130
;             // radio_transmit the application report
;             status = protocol_send_packet(APP_TX_PACKET_SIZE);        
	mov A,3
	push A
	xcall _protocol_send_packet
	add SP,-1
	mov [X+3],A
	.dbline 132
;             
;             if( status == DATA_SENT )
	cmp [X+3],41
	jnz L33
	.dbline 133
;             {
	.dbline 134
;                 do_leds();
	xcall _do_leds
	.dbline 135
;                 set_connect_led(ON);
	mov A,1
	push A
	xcall _set_connect_led
	add SP,-1
	.dbline 136
;             }
	xjmp L34
L33:
	.dbline 137
;             else if ( status == TX_TIMEOUT_ERR )
	cmp [X+3],5
	jnz L35
	.dbline 138
;             {
	.dbline 139
;                 do_leds();
	xcall _do_leds
	.dbline 140
;             }  
L35:
L34:
	.dbline 141
;         } //   if( mode != NO_ACTIVITY )
L31:
	.dbline 142
;         if(mode == NO_ACTIVITY)
	cmp [X+0],0
	jnz L37
	.dbline 143
;         {
	.dbline 144
;             if(bind_pressed())
	xcall _bind_pressed
	cmp A,0
	jz L39
	.dbline 145
;             {
	.dbline 146
;                 set_bind_led(ON); 
	mov A,1
	push A
	xcall _set_bind_led
	add SP,-1
	.dbline 149
; 
;                 // turn off the Connect LED
;                 set_connect_led(OFF); 
	mov A,0
	push A
	xcall _set_connect_led
	.dbline 152
; 
;                 // perform the bind routine
;                 bind_status = protocol_bind();
	xcall _protocol_bind
	mov [X+6],A
	.dbline 154
; 
;                 set_bind_led(OFF);
	mov A,0
	push A
	xcall _set_bind_led
	add SP,-2
	.dbline 156
; 
;                 if (bind_status == LS_STATUS_SUCCESS) 
	cmp [X+6],0
	jnz L41
	.dbline 157
;                 {
	.dbline 158
;                     set_connect_led(ON);
	mov A,1
	push A
	xcall _set_connect_led
	add SP,-1
	.dbline 159
;                 }
L41:
	.dbline 160
;             }            
L39:
	.dbline 161
;         }
L37:
	.dbline 164
	mov A,0
	push A
	mov A,10
	push A
	mov A,[X+1]
	push A
	mov A,[X+2]
	push A
	xcall _timer_delay_incremental
	add SP,-4
	.dbline 167
	xcall _timer_timer_off
	.dbline 168
	xcall _timer_timer_on
	.dbline 170
L29:
	.dbline 119
	xjmp L28
X0:
	.dbline -2
	.dbline 172
;         
;         // control the TX period
;         TIMER_DELAY_INCREMENTAL( ts, KP_PERIOD);
; 
;         // Prevent "Tick" rollover by turning the timer off and on
;         timer_timer_off();
;         timer_timer_on(); 
;         
;     }  // while(1)
; 
; }  // end main
L25:
	add SP,-10
	pop X
	.dbline 0 ; func end
	jmp .
	.dbsym l col 9 c
	.dbsym l column_port_shadow 8 c
	.dbsym l row 7 c
	.dbsym l bind_status 6 c
	.dbsym l tx_pkt 4 pX
	.dbsym l status 3 c
	.dbsym l ts 1 s
	.dbsym l mode 0 c
	.dbend
