	.module mfgtest.c
	.area text(rom, con, rel)
	.dbfile ./mfgtest.c
	.dbfunc e mfg_test _mfg_test fV
;        results -> X+1
;         status -> X+0
_mfg_test::
	.dbline -1
	push X
	mov X,SP
	add SP,5
	.dbline 135
; //--------------------------------------------------------------------------
; //! \file
; //!
; //! This module implements a manufacturing test mode
; //!
; //--------------------------------------------------------------------------
; // $Archive: $
; // $Modtime: $
; // $Revision: 1.4 $
; //--------------------------------------------------------------------------
; //
; // Copyright 2004, Cypress Semiconductor Corporation.
; //
; // This software is owned by Cypress Semiconductor Corporation (Cypress)
; // and is protected by and subject to worldwide patent protection (United
; // States and foreign), United States copyright laws and international 
; // treaty provisions. Cypress hereby grants to licensee a personal, 
; // non-exclusive, non-transferable license to copy, use, modify, create 
; // derivative works of, and compile the Cypress Source Code and derivative 
; // works for the sole purpose of creating custom software in support of 
; // licensee product to be used only in conjunction with a Cypress integrated 
; // circuit as specified in the applicable agreement. Any reproduction, 
; // modification, translation, compilation, or representation of this 
; // software except as specified above is prohibited without the express 
; // written permission of Cypress.
; //
; // Disclaimer: CYPRESS MAKES NO WARRANTY OF ANY KIND,EXPRESS OR IMPLIED, 
; // WITH REGARD TO THIS MATERIAL, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
; // WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
; // Cypress reserves the right to make changes without further notice to the
; // materials described herein. Cypress does not assume any liability arising
; // out of the application or use of any product or circuit described herein.
; // Cypress does not authorize its products for use as critical components in
; // life-support systems where a malfunction or failure may reasonably be
; // expected to result in significant injury to the user. The inclusion of
; // Cypress product in a life-support systems application implies that the
; // manufacturer assumes all risk of such use and in doing so indemnifies
; // Cypress against all charges.
; //
; // Use may be limited by and subject to the applicable Cypress software
; // license agreement.
; //
; //--------------------------------------------------------------------------
; 
; 
; //--------------------------------------
; // Included files
; //--------------------------------------
; 
; #include "GlobalParams.h"
; #include "mfgtest.h"
; #include "radio.h"
; #include "protocol.h"
; 
; 
; //--------------------------------------
; // Local Definitions and Types
; //--------------------------------------
; 
; // Optionally compile complete module
; #if defined(USE_MFG_TEST)
; 
; //! Used to count good and erased bits
; extern UINT8 channel_valid[];
; 
; // Length (bytes) of receive data.  Used in mfg_receive_test_packets() 
; extern UINT8 rx_data_length;
; 
; 
; //! 8 PN codes for a data rate of 32kbps or 64kbps, and 48 PN codes for a
; //! data rate of 16kbps
; extern const UINT8 pn_code_table[];
; 
; //! To keep track of the total received/erased bits
; typedef struct 
; {
;     //! Total number of bits received
;     UINT16 total_received_bits;
;     //! Total number of bits erased
;     UINT16 total_erased_bits;
; 
; } MFG_RESULTS;
; 
; //! Header for the manufacturing test packet
; #define MFG_HDR_TEST      0xF1
; 
; //! Header for the first manufacturing results packet
; #define MFG_HDR_RES1      0xFB
; 
; //! Header for the second manufacturing results packet
; #define MFG_HDR_RES2      0xFD
; 
; //! Header for the third manufacturing results packet
; #define MFG_HDR_RES3      0xFE
; 
; 
; //! Size of manufacturing test packet
; #define MFG_TEST_PKT_SIZE (MFG_PACKET_PAYLOAD_SIZE + 2) // add header & checksum
; 
; //! Size of manufacturing results packet
; #define MFG_RES_PKT_SIZE  10
; 
; 
; //--------------------------------------
; // Local Function Declarations
; //--------------------------------------
; 
; static void mfg_setup_radio(void);
; static BOOL mfg_receive_test_packets(MFG_RESULTS *);
; static void mfg_send_test_packets(void);
; static void mfg_send_results(MFG_RESULTS *);
; static void mfg_send_result_packet(UINT8 *pkt);
; 
; 
; //--------------------------------------------------------------------------
; // mfg_check_test
; //--------------------------------------------------------------------------
; 
; 
; ///////////////////////////////////////////////////////////////////////////////
; //
; //  Function:    mfg_test
; //
; //!  Description: The main manufacturing test routine continuously clears
; //!               the watchdog and sleep, sets the radio up for manufacturing
; //!               test mode, and receives data packets.  If the data packets
; //!               valid manufacturing test packets, then they are transmitted
; //!
; //!  Inputs:      Void
; //!
; //!  Returns:     Void
; //!
; ///////////////////////////////////////////////////////////////////////////////
; void mfg_test()
; {
	xjmp L28
L27:
	.dbline 140
;     MFG_RESULTS results;
;     BOOL status;
; 
;     while(1)
;     {
	.dbline 142
;         // Clear Watchdog and Sleep
;         M8C_ClearWDTAndSleep;
	mov REG[0xe3],56
	.dbline 144
; 
;         mfg_setup_radio();
	xcall _mfg_setup_radio
	.dbline 146
; 
;         status = mfg_receive_test_packets(&results);
	mov [__r1],X
	add [__r1],1
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	xcall _mfg_receive_test_packets
	add SP,-2
	mov [X+0],A
	.dbline 148
; 
;         if( status )
	cmp [X+0],0
	jz L30
	.dbline 149
;         {
	.dbline 150
;             mfg_send_test_packets();
	xcall _mfg_send_test_packets
	.dbline 152
; 
;             mfg_send_results(&results);
	mov [__r1],X
	add [__r1],1
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	xcall _mfg_send_results
	add SP,-2
	.dbline 153
;         }
L30:
	.dbline 155
L28:
	.dbline 139
	xjmp L27
X0:
	.dbline -2
	.dbline 156
; 
;     }
; }
L26:
	add SP,-5
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l results 1 X
	.dbsym l status 0 c
	.dbend
	.dbfunc s mfg_setup_radio _mfg_setup_radio fV
_mfg_setup_radio:
	.dbline -1
	.dbline 174
; 
; 
; ///////////////////////////////////////////////////////////////////////////////
; //
; //  Function:    mfg_setup_radio
; //
; //!  Description: This routine sets up the radio for manufacturing test mode
; //!               by first waking the radio up.  Then the radio is setup with
; //!               pn code, channel, power level, and thresholds used for 
; //!               manufacturing test mode
; //!
; //!  Inputs:      Void
; //!
; //!  Returns:     Void
; //!
; ///////////////////////////////////////////////////////////////////////////////
; static void mfg_setup_radio()
; {
	.dbline 179
; #ifdef RADIO_SLEEP_ENABLED
;     radio_wakeup();
; #endif
; 
;     SPI_RADIO_PUT(REG_THRESHOLD_LO, MFG_THRESHOLD_LO & THRESHOLD_MASK);
	mov A,1
	push A
	mov A,-103
	push A
	xcall _spi_radio_access
	.dbline 181
; 
;     SPI_RADIO_PUT(REG_THRESHOLD_HI, MFG_THRESHOLD_HI & THRESHOLD_MASK);
	mov A,31
	push A
	mov A,-102
	push A
	xcall _spi_radio_access
	add SP,-4
	.dbline 183
; 
;     SPI_RADIO_PUT(REG_PA, MFG_PA_BIAS & PA_BIAS_MASK);
	mov A,7
	push A
	mov A,-93
	push A
	xcall _spi_radio_access
	.dbline 185
; 
;     SPI_RADIO_PUT(REG_SERDES_CTL, 
	mov A,15
	push A
	mov A,-122
	push A
	xcall _spi_radio_access
	add SP,-4
	.dbline 188
;                   SERDES_ENABLE | MFG_EOF_TIMEOUT & EOF_LEN_MASK );
;     
;     radio_set_pn_code(&pn_code_table[(8 * MFG_PN_CODE)]);
	mov A,>_pn_code_table+8
	push A
	mov A,<_pn_code_table+8
	push A
	xcall _radio_set_pn_code
	.dbline 190
; 
;     radio_set_channel(MFG_CHANNEL);
	mov A,1
	push A
	xcall _radio_set_channel
	add SP,-3
	.dbline -2
	.dbline 191
; }
L32:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc s mfg_receive_test_packets _mfg_receive_test_packets fc
;       received -> X+14
;            pkt -> X+9
;   current_time -> X+7
; erased_bits_in_packet -> X+5
; good_bits_in_packet -> X+3
;           bits -> X+2
;          count -> X+0
;        results -> X-5
_mfg_receive_test_packets:
	.dbline -1
	push X
	mov X,SP
	add SP,15
	.dbline 216
; 
; 
; ///////////////////////////////////////////////////////////////////////////////
; //
; //  Function:    mfg_receive_test_packets
; //
; //!  Description: This routine continuously receives the test packets and 
; //!               checks/counts good/erased bits, unless a timeout occurred
; //!               during the packet receive test or all packets have been 
; //!               fully received. The packets are received through 
; //!               radio_receive().  The total amount of good/erased bits for 
; //!               all packets are updated as the totals for individual packets
; //!               are calculated.
; //!               
; //!  Inputs:      
; //!               - *results - Used for counting the received bits and erased 
; //!               bits
; //!
; //!  Returns:     
; //!               - TRUE - received successfully
; //!               - FALSE - not received successfully
; //!
; ///////////////////////////////////////////////////////////////////////////////
; static BOOL mfg_receive_test_packets(MFG_RESULTS *results)
; {
	.dbline 220
;     UINT8       pkt[MFG_TEST_PKT_SIZE];
;     UINT16      good_bits_in_packet;
;     UINT16      erased_bits_in_packet;
;     BOOL        received = FALSE;
	mov [X+14],0
	.dbline 225
;     UINT16      count;
;     UINT8       bits;
;     TIME_STAMP  current_time;
; 
;     results->total_received_bits = 0;
	mov A,[X-4]
	mov [__r1],A
	mov A,0
	mvi [__r1],A
	mvi [__r1],A
	.dbline 226
;     results->total_erased_bits = 0;
	mov A,[X-4]
	add A,2
	mov [__r1],A
	mov A,0
	mvi [__r1],A
	mvi [__r1],A
	xjmp L36
L35:
	.dbline 230
; 
;     // Get packets with timeout
;     while(1)
;     {
	.dbline 231
;         current_time = timer_get_time_stamp();
	xcall _timer_get_time_stamp
	mov A,[__r1]
	mov [X+8],A
	mov A,[__r0]
	mov [X+7],A
L38:
	.dbline 234
;         
;         do
;         {
	.dbline 236
;             // Clear Watchdog and Sleep
;             M8C_ClearWDTAndSleep;
	mov REG[0xe3],56
	.dbline 238
; 
;             if( radio_receive(MFG_TEST_PKT_SIZE, pkt, channel_valid, 255) > 0 )
	mov A,0
	push A
	mov A,-1
	push A
	mov A,>_channel_valid
	push A
	mov A,<_channel_valid
	push A
	mov [__r1],X
	add [__r1],9
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	mov A,5
	push A
	xcall _radio_receive
	add SP,-7
	mov [__r0],A
	mov A,0
	cmp A,[__r0]
	jnc L41
X2:
	.dbline 239
;             {
	.dbline 240
;                 break;
	xjmp L40
L41:
	.dbline 242
;             }
;         }
L39:
	.dbline 243
;         while( !timer_time_elapsed(current_time, MFG_RX_TIMEOUT) );
	mov A,0
	push A
	mov A,100
	push A
	mov A,[X+7]
	push A
	mov A,[X+8]
	push A
	xcall _timer_time_elapsed
	add SP,-4
	cmp A,0
	jz L38
L40:
	.dbline 245
; 
;         if( rx_data_length == 0 )
	cmp [_rx_data_length],0
	jnz L43
	.dbline 246
;         {
	.dbline 247
;             if( received )
	cmp [X+14],0
	jz L36
	.dbline 248
;             {
	.dbline 250
;                 // Timeout during packet receive test
;                 break;
	xjmp L37
X1:
	.dbline 253
;             }
;             else
;             {
	.dbline 255
;                 // Still waiting for start of packets
;                 continue;
L43:
	.dbline 260
;             }
;         }
; 
;         // Count valid bits in the packet
;         received = TRUE;
	mov [X+14],1
	.dbline 261
;         good_bits_in_packet = 0;
	mov [X+4],0
	mov [X+3],0
	.dbline 262
;         erased_bits_in_packet = 0;
	mov [X+6],0
	mov [X+5],0
	.dbline 264
; 
;         for(count = 0; count < rx_data_length; count++)
	mov [X+1],0
	mov [X+0],0
	xjmp L50
L47:
	.dbline 265
;         {
	.dbline 266
;             for(bits=0; bits<8; bits++)
	mov [X+2],0
	xjmp L54
L51:
	.dbline 267
;             {
	.dbline 268
;                 if( (channel_valid[count] & 0x01) == 0x01 )
	mov A,[X+1]
	add A,<_channel_valid
	mov [__r1],A
	mvi A,[__r1]
	and A,1
	cmp A,1
	jnz L55
	.dbline 269
;                 {
	.dbline 270
;                     ++good_bits_in_packet;
	inc [X+4]
	adc [X+3],0
	.dbline 271
;                 }
	xjmp L56
L55:
	.dbline 273
;                 else
;                 {
	.dbline 274
;                     ++erased_bits_in_packet;
	inc [X+6]
	adc [X+5],0
	.dbline 275
;                 }
L56:
	.dbline 277
	mov A,[X+1]
	add A,<_channel_valid
	mov [__r1],A
	mov A,[X+0]
	adc A,>_channel_valid
	mov [__r0],A
	mvi A,[__r1]
	dec [__r1]
	mov [__r2],A
	and F,-5
	rrc [__r2]
	mov A,[__r2]
	mvi [__r1],A
	.dbline 278
L52:
	.dbline 266
	inc [X+2]
L54:
	.dbline 266
	cmp [X+2],8
	jc L51
X3:
	.dbline 281
	mov REG[0xe3],56
	.dbline 282
L48:
	.dbline 264
	inc [X+1]
	adc [X+0],0
L50:
	.dbline 264
	mov [__r1],[_rx_data_length]
	mov [__r0],0
	mov A,[X+1]
	sub A,[__r1]
	mov A,[X+0]
	sbb A,[__r0]
	jc L47
X4:
	.dbline 285
; 
;                 channel_valid[count] >>= 1;
;             }
; 
;             // Clear Watchdog and Sleep
;             M8C_ClearWDTAndSleep;
;         }
; 
;         // Check for noise
;         if( good_bits_in_packet >= 4 )
	mov A,[X+4]
	sub A,4
	mov A,[X+3]
	sbb A,0
	jc L57
X5:
	.dbline 286
;         {
	.dbline 287
;             results->total_received_bits += 8 * rx_data_length;
	mov [__r1],[_rx_data_length]
	mov [__r0],0
	asl [__r1]
	rlc [__r0]
	asl [__r1]
	rlc [__r0]
	asl [__r1]
	rlc [__r0]
	mov A,[X-4]
	mov [__r3],A
	mvi A,[__r3]
	mov [__r2],A
	mvi A,[__r3]
	add A,[__r1]
	mov [__r1],A
	mov A,[__r2]
	adc A,[__r0]
	mov [__r0],A
	mov A,[X-4]
	mov [__r3],A
	mov A,[__r0]
	mvi [__r3],A
	mov A,[__r1]
	mvi [__r3],A
	.dbline 288
;             results->total_erased_bits += erased_bits_in_packet;
	mov A,[X-4]
	add A,2
	mov [__r1],A
	mov A,[X-5]
	adc A,0
	mov [__r0],A
	mvi A,[__r1]
	mov [__r2],A
	mvi A,[__r1]
	sub [__r1],2
	mov [__r3],A
	mov A,[X+6]
	add [__r3],A
	mov A,[X+5]
	adc [__r2],A
	mov A,[__r2]
	mvi [__r1],A
	mov A,[__r3]
	mvi [__r1],A
	.dbline 289
;         }
L57:
	.dbline 291
; 
;         count = ((UINT16)*((UINT8 *) (&rx_packet.first.byte) + 1) << 8) | *((UINT8 *) (&rx_packet.first.byte) + 2);
	mov [__r0],[_rx_packet+1]
	mov A,[_rx_packet+2]
	mov [X+1],A
	mov A,[__r0]
	mov [X+0],A
	.dbline 293
; 
;         if( count == MFG_NUM_PACKETS - 1 )
	cmp [X+0],0
	jnz L61
	cmp [X+1],-57
	jnz L61
X6:
	.dbline 294
;         {
	.dbline 295
;             break;
	xjmp L37
L61:
	.dbline 297
L36:
	.dbline 229
	xjmp L35
L37:
	.dbline 299
;         }
;     }
; 
;     return received;
	mov A,[X+14]
	.dbline -2
L34:
	add SP,-15
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l received 14 c
	.dbsym l pkt 9 A[5:5]c
	.dbsym l current_time 7 s
	.dbsym l erased_bits_in_packet 5 s
	.dbsym l good_bits_in_packet 3 s
	.dbsym l bits 2 c
	.dbsym l count 0 s
	.dbsym l results -5 pX
	.dbend
	.dbfunc s mfg_send_test_packets _mfg_send_test_packets fV
;            idx -> X+6
;            pkt -> X+1
;           idx2 -> X+0
_mfg_send_test_packets:
	.dbline -1
	push X
	mov X,SP
	add SP,8
	.dbline 318
; }
; 
; 
; ///////////////////////////////////////////////////////////////////////////////
; //
; //  Function:    mfg_send_test_packets
; //
; //!  Description: Transmits MFG_NUM_PACKETS (currently 200) manufacturing test
; //!               packets.  Before each one is sent, the watchdog and sleep is 
; //!               cleared and the packet is made and transmitted.  There is a
; //!               delay before each packet is sent.  
; //!
; //!  Inputs:      Void
; //!
; //!  Returns:     Void
; //!
; ///////////////////////////////////////////////////////////////////////////////
; static void mfg_send_test_packets(void)
; {
	.dbline 324
;     UINT8  pkt[MFG_TEST_PKT_SIZE];
;     UINT16 idx;
;     UINT8  idx2;
; 
; 
;     timer_delay_msec(MFG_PRE_TX_DELAY);
	mov A,0
	push A
	mov A,50
	push A
	xcall _timer_delay_msec
	add SP,-2
	.dbline 326
; 
;     for(idx=0; idx < MFG_NUM_PACKETS; idx++)
	mov [X+7],0
	mov [X+6],0
	xjmp L67
L64:
	.dbline 327
;     {
	.dbline 329
;         // Clear Watchdog and Sleep
;         M8C_ClearWDTAndSleep;
	mov REG[0xe3],56
	.dbline 332
; 
;         // Build packet
;         pkt[0] = MFG_HDR_TEST;
	mov [X+1],-15
	.dbline 333
;         pkt[1] = idx >> 8;
	mov A,[X+6]
	mov [X+2],A
	.dbline 334
;         pkt[2] = idx & 0xFF;
	mov A,[X+7]
	mov [X+3],A
	.dbline 336
;         
;         for(idx2=3; idx2 < MFG_TEST_PKT_SIZE-1; idx2++)
	mov [X+0],3
	xjmp L73
L70:
	.dbline 337
	.dbline 338
	mov A,[X+0]
	add A,65
	sub A,3
	mov [__r0],A
	mov [__r3],X
	add [__r3],1
	mov A,[X+0]
	add A,[__r3]
	mov [__r3],A
	mov A,[__r0]
	mvi [__r3],A
	.dbline 339
L71:
	.dbline 336
	inc [X+0]
L73:
	.dbline 336
	cmp [X+0],4
	jc L70
X7:
	.dbline 341
	mov A,0
	push A
	mov A,4
	push A
	mov [__r1],X
	add [__r1],1
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	xcall _protocol_calc_ck_sum
	add SP,-4
	mov [__r0],A
	mov [__r3],X
	add [__r3],1
	mov A,[X+0]
	add A,[__r3]
	mov [__r3],A
	mov A,[__r0]
	mvi [__r3],A
	.dbline 343
	mov [__r1],X
	add [__r1],1
	push A
	mov A,[__r1]
	push A
	mov A,5
	push A
	xcall _radio_transmit
	.dbline 345
	mov A,0
	push A
	mov A,5
	push A
	xcall _timer_delay_msec
	add SP,-5
	.dbline 346
L65:
	.dbline 326
	inc [X+7]
	adc [X+6],0
L67:
	.dbline 326
	mov A,[X+7]
	sub A,-56
	mov A,[X+6]
	sbb A,0
	jc L64
X8:
	.dbline -2
	.dbline 347
;         {
;             pkt[idx2] = 'A' + idx2 - 3;
;         }
; 
;         pkt[idx2] = protocol_calc_ck_sum(pkt, MFG_TEST_PKT_SIZE-1, 0);
; 
;         radio_transmit(MFG_TEST_PKT_SIZE, pkt);
; 
;         timer_delay_msec(MFG_INTER_TX_DELAY);
;     }
; }
L63:
	add SP,-8
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l idx 6 s
	.dbsym l pkt 1 A[5:5]c
	.dbsym l idx2 0 c
	.dbend
	.dbfunc s mfg_send_results _mfg_send_results fV
;            idx -> X+10
;            pkt -> X+0
;        results -> X-5
_mfg_send_results:
	.dbline -1
	push X
	mov X,SP
	add SP,11
	.dbline 370
; 
; 
; ///////////////////////////////////////////////////////////////////////////////
; //
; //  Function:    mfg_send_results
; //
; //!  Description: Sends three result packets (Each with its own header  
; //!               attribute, i.e. MFG_HDR_RES1) and checksum: First, sends a
; //!               packet with number of total bits received.  Second, sends a
; //!               packet with number of total bits erased.  Then, it sends a
; //!               packet with everything set to 0.   
; //!
; //!  Inputs:      
; //!               - *results - Holds the total_received_bits and 
; //!               total_erased_bits that were set up in 
; //!               mfg_receive_test_packets()
; //!
; //!  Returns:     Void
; //!
; ///////////////////////////////////////////////////////////////////////////////
; 
; static void mfg_send_results(MFG_RESULTS *results)
; {
	.dbline 375
;     UINT8 pkt[MFG_RES_PKT_SIZE];
;     UINT8 idx;
; 
;     // Build results 1 packet
;     pkt[0] = MFG_HDR_RES1;
	mov [X+0],-5
	.dbline 376
;     pkt[1] = 0;
	mov [X+1],0
	.dbline 377
;     pkt[2] = 0;
	mov [X+2],0
	.dbline 378
;     pkt[3] = 0;
	mov [X+3],0
	.dbline 379
;     pkt[4] = 0;
	mov [X+4],0
	.dbline 380
;     pkt[5] = 0;
	mov [X+5],0
	.dbline 381
;     pkt[6] = 0;
	mov [X+6],0
	.dbline 382
;     pkt[7] = results->total_received_bits >> 8;
	mov A,[X-4]
	mov [__r1],A
	mvi A,[__r1]
	mov [__r0],A
	mvi A,[__r1]
	mov A,[__r0]
	mov [X+7],A
	.dbline 383
;     pkt[8] = results->total_received_bits & 0xFF;
	mov A,[X-4]
	mov [__r1],A
	mvi A,[__r1]
	mov [__r0],A
	mvi A,[__r1]
	and [__r0],0
	mov [__r0],A
	mov [X+8],A
	.dbline 384
;     pkt[9] = protocol_calc_ck_sum(pkt, 9, 0);
	mov A,0
	push A
	mov A,9
	push A
	mov A,[__r0]
	push A
	push X
	xcall _protocol_calc_ck_sum
	mov [X+9],A
	.dbline 386
; 
;     mfg_send_result_packet(pkt);
	push A
	push X
	xcall _mfg_send_result_packet
	add SP,-6
	.dbline 390
; 
; 
;     // Build results 2 packet
;     pkt[0] = MFG_HDR_RES2;
	mov [X+0],-3
	.dbline 391
;     pkt[1] = 0;
	mov [X+1],0
	.dbline 392
;     pkt[2] = 0;
	mov [X+2],0
	.dbline 393
;     pkt[3] = results->total_erased_bits >> 8;
	mov A,[X-4]
	add A,2
	mov [__r1],A
	mvi A,[__r1]
	mov [__r0],A
	mvi A,[__r1]
	mov A,[__r0]
	mov [X+3],A
	.dbline 394
;     pkt[4] = results->total_erased_bits & 0xFF;
	mov A,[X-4]
	add A,2
	mov [__r1],A
	mvi A,[__r1]
	mov [__r0],A
	mvi A,[__r1]
	and [__r0],0
	mov [__r0],A
	mov [X+4],A
	.dbline 395
;     pkt[5] = 0;
	mov [X+5],0
	.dbline 396
;     pkt[6] = 0;
	mov [X+6],0
	.dbline 397
;     pkt[7] = 0;
	mov [X+7],0
	.dbline 398
;     pkt[8] = 0;
	mov [X+8],0
	.dbline 399
;     pkt[9] = protocol_calc_ck_sum(pkt, 9, 0);
	mov A,0
	push A
	mov A,9
	push A
	mov A,[__r0]
	push A
	push X
	xcall _protocol_calc_ck_sum
	mov [X+9],A
	.dbline 401
; 
;     mfg_send_result_packet(pkt);
	push A
	push X
	xcall _mfg_send_result_packet
	add SP,-6
	.dbline 405
; 
; 
;     // Build results 3 packet
;     pkt[0] = MFG_HDR_RES3;
	mov [X+0],-2
	.dbline 407
; 
;     for(idx=1; idx<9; idx++)
	mov [X+10],1
	xjmp L96
L93:
	.dbline 408
	.dbline 409
	mov [__r1],X
	mov A,[X+10]
	add A,[__r1]
	mov [__r1],A
	mov A,0
	mvi [__r1],A
	.dbline 410
L94:
	.dbline 407
	inc [X+10]
L96:
	.dbline 407
	cmp [X+10],9
	jc L93
X9:
	.dbline 412
;     {
;         pkt[idx] = 0;
;     }
; 
;     pkt[9] = protocol_calc_ck_sum(pkt, 9, 0);
	mov A,0
	push A
	mov A,9
	push A
	mov A,[__r0]
	push A
	push X
	xcall _protocol_calc_ck_sum
	mov [X+9],A
	.dbline 414
; 
;     mfg_send_result_packet(pkt);
	push A
	push X
	xcall _mfg_send_result_packet
	add SP,-6
	.dbline -2
	.dbline 415
; }
L74:
	add SP,-11
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l idx 10 c
	.dbsym l pkt 0 A[10:10]c
	.dbsym l results -5 pX
	.dbend
	.dbfunc s mfg_send_result_packet _mfg_send_result_packet fV
;            idx -> X+0
;            pkt -> X-5
_mfg_send_result_packet:
	.dbline -1
	push X
	mov X,SP
	add SP,1
	.dbline 435
; 
; 
; ///////////////////////////////////////////////////////////////////////////////
; //
; //  Function:    mfg_send_result_packet
; //
; //!  Description: Transmits the actual packets that are set up in 
; //!               mfg_send_results() by clearing the watchdog and sleep to get
; //!               full period, the calling radio_transmit() to transmit the 
; //!               packet (*pkt) being received.  A delay occurs before each
; //!               transmission. 
; //!
; //!  Inputs:      
; //!               - *pkt - Holds the packet data to transmit 
; //!
; //!  Returns:     Void
; //!
; ///////////////////////////////////////////////////////////////////////////////
; static void mfg_send_result_packet(UINT8 *pkt)
; {
	.dbline 438
;     UINT8 idx;
; 
;     timer_delay_msec(MFG_PRE_RESULTS_DELAY);
	mov A,0
	push A
	mov A,100
	push A
	xcall _timer_delay_msec
	add SP,-2
	.dbline 440
; 
;     for(idx=0; idx<MFG_NUM_RESULTS_PACKETS; idx++)
	mov [X+0],0
	xjmp L102
L99:
	.dbline 441
	.dbline 443
	mov REG[0xe3],56
	.dbline 445
	mov A,[X-5]
	push A
	mov A,[X-4]
	push A
	mov A,10
	push A
	xcall _radio_transmit
	.dbline 447
	mov A,0
	push A
	mov A,5
	push A
	xcall _timer_delay_msec
	add SP,-5
	.dbline 448
L100:
	.dbline 440
	inc [X+0]
L102:
	.dbline 440
	cmp [X+0],5
	jc L99
X10:
	.dbline -2
	.dbline 449
;     {
;         // Clear Watchdog and Sleep
;         M8C_ClearWDTAndSleep;
; 
;         radio_transmit(MFG_RES_PKT_SIZE, pkt);
; 
;         timer_delay_msec(MFG_INTER_RESULTS_DELAY);
;     }
; }
L98:
	add SP,-1
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l idx 0 c
	.dbsym l pkt -5 pc
	.dbend
