	.module pdc9075.c
	.area lit(rom, con, rel)
_LEDpattern::
	.byte 254,253
	.byte 251,247
	.byte 239,223
	.byte 191,127
	.byte 191,223
	.byte 239,247
	.byte 251,253
	.dbfile ./pdc9075.c
	.dbsym e LEDpattern _LEDpattern A[14:14]c
	.area text(rom, con, rel)
	.dbfile ./pdc9075.c
	.dbfunc e platform_init _platform_init fV
_platform_init::
	.dbline -1
	.dbline 80
; //--------------------------------------------------------------------------
; //! \file
; //!
; //!  Collection of routines to initialize and access the PSOC
; //!  ports specifically for the PDC-9075 board
; //!
; //--------------------------------------------------------------------------
; // $Archive: /WirelessUSB/LS/Firmware/LS DVK/PSoC/DVK Keypad/pdc9075.c $
; // $Modtime: 3/04/04 2:42p $
; // $Revision: 1.4 $
; //--------------------------------------------------------------------------
; //
; // Copyright 2003-2004, Cypress Semiconductor Corporation.
; //
; // This software is owned by Cypress Semiconductor Corporation (Cypress)
; // and is protected by and subject to worldwide patent protection (United
; // States and foreign), United States copyright laws and international 
; // treaty provisions. Cypress hereby grants to licensee a personal, 
; // non-exclusive, non-transferable license to copy, use, modify, create 
; // derivative works of, and compile the Cypress Source Code and derivative 
; // works for the sole purpose of creating custom software in support of 
; // licensee product to be used only in conjunction with a Cypress integrated 
; // circuit as specified in the applicable agreement. Any reproduction, 
; // modification, translation, compilation, or representation of this 
; // software except as specified above is prohibited without the express 
; // written permission of Cypress.
; //
; // Disclaimer: CYPRESS MAKES NO WARRANTY OF ANY KIND,EXPRESS OR IMPLIED, 
; // WITH REGARD TO THIS MATERIAL, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
; // WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
; // Cypress reserves the right to make changes without further notice to the
; // materials described herein. Cypress does not assume any liability arising
; // out of the application or use of any product or circuit described herein.
; // Cypress does not authorize its products for use as critical components in
; // life-support systems where a malfunction or failure may reasonably be
; // expected to result in significant injury to the user. The inclusion of
; // Cypress product in a life-support systems application implies that the
; // manufacturer assumes all risk of such use and in doing so indemnifies
; // Cypress against all charges.
; //
; // Use may be limited by and subject to the applicable Cypress software
; // license agreement.
; //
; //--------------------------------------------------------------------------
; 
; //--------------------------------------
; // Included files
; //--------------------------------------
; #include "spi_clk.h"
; #include "timer.h"
; #include "pdc9075.h"
; 
; 
; //--------------------------------------
; // Local Definitions and Types
; //--------------------------------------
; 
; //! Pattern array for LED's
; const  UINT8 LEDpattern[] = {0xFE, 0xFD, 0xFB, 0xF7, 0xEF, 0xDF, 0xBF, 0x7F,
;                              0xBF, 0xDF, 0xEF, 0xF7, 0xFB, 0xFD};
; //! For moving to different elements of the LED array
; static UINT8 led_index;
; 
; 
; 
; ///////////////////////////////////////////////////////////////////////////////
; //
; //   Function:    platform_init
; //
; //!  Description: Initialize the PSOC ports for the PDC-9075 board by setting
; //!               up the serial port, initializing ports 4 and 5 for switches,
; //!               and by clearing the green and red LEDs
; //!
; //!  Inputs:      Void
; //!
; //!  Returns:     Void
; //!
; ///////////////////////////////////////////////////////////////////////////////
; void platform_init()
; {
	.dbline 81
;     SPI_Clk_Start();
	push X
	xcall _SPI_Clk_Start
	pop X
	.dbline 84
;     
;     // initialize port 4 and 5 for reading switches
;     sw_ports_init();
	xcall _sw_ports_init
	.dbline 87
;     
;     // clear red and green LEDS
;     LED_PORT_DR = LEDS_OFF;
	mov REG[0x10],10
	.dbline -2
	.dbline 88
; }
L1:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e sw_ports_init _sw_ports_init fV
_sw_ports_init::
	.dbline -1
	.dbline 104
; 
; 
; ///////////////////////////////////////////////////////////////////////////////
; //
; //   Function:    sw_ports_init
; //
; //!  Description: Initialize ports 4 and 5 for reading switches on
; //!               the keypad, joystick, and the selector switch.
; //!
; //!  Inputs:      Void
; //!
; //!  Returns:     Void
; //!
; ///////////////////////////////////////////////////////////////////////////////
; void sw_ports_init()
; {
	.dbline 107
; 
;     // enable the row pullups
;     PRT5DR |= (ROW_0 | ROW_1 | ROW_2 | ROW_3);
	or REG[0x14],15
	.dbline 109
;     // drive all the columns high
;     COL_PORT_DR = (COL_0 | COL_1 | COL_2 | COL_3 | COL_4 | COL_5 | COL_6 | COL_7);
	mov REG[0xc],-1
	.dbline -2
	.dbline 110
; }
L2:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e check_buttons_active _check_buttons_active fc
; column_port_shadow -> X+5
;          index -> X+4
;            row -> X+3
;            col -> X+2
;           mask -> X+1
;        row_bit -> X+0
_check_buttons_active::
	.dbline -1
	push X
	mov X,SP
	add SP,6
	.dbline 130
; 
; 
; ///////////////////////////////////////////////////////////////////////////////
; //
; //  Function:    check_buttons_active
; //
; //!  Description: Scan the keypad button ports for activity via each column/
; //!               row combination and sets the button state dependent upon 
; //!               which buttons are held down.  Then restores the port used by
; //!               the column
; //!
; //!  Inputs:      Void
; //!
; //!  Returns:     
; //!               - 0 - No activity
; //!               - 1 - Button down
; //!
; ///////////////////////////////////////////////////////////////////////////////
; UINT8 check_buttons_active()
; {
	.dbline 138
;     UINT8 index;
;     UINT8 row;
;     UINT8 col;
;     UINT8 mask;
;     UINT8 row_bit;
;     UINT8 column_port_shadow;
; 
;     column_port_shadow = COL_PORT_DR;
	mov A,REG[0xc]
	mov [X+5],A
	.dbline 139
;     for(col = 0; col < COLUMNS; ++col)
	mov [X+2],0
	xjmp L7
L4:
	.dbline 140
;     {
	.dbline 142
;         // drive the column
;         COL_PORT_DR = ~(0x01 << col);
	mov [__r0],1
	mov A,[X+2]
	and A,7
	jz X0
X1:
	asl [__r0]
	dec A
	jnz X1
X0:
	mov A,[__r0]
	cpl A
	mov REG[0xc],A
	.dbline 144
;         // read the row
;         row = PRT5DR;
	mov A,REG[0x14]
	mov [X+3],A
	.dbline 145
;         row &= (ROW_0 | ROW_1 | ROW_2 | ROW_3);
	and [X+3],15
	.dbline 146
;         mask = 0x01;
	mov [X+1],1
	.dbline 147
;         for(mask = 0x01, row_bit = 0;row_bit < ROWS; ++row_bit, mask <<= 1)
	mov [X+1],1
	mov [X+0],0
	xjmp L11
L8:
	.dbline 148
;         {
	.dbline 149
;             index = (col * ROWS) + row_bit;           
	mov A,[X+2]
	asl A
	asl A
	add A,[X+0]
	mov [X+4],A
	.dbline 150
;             if(!(row & mask))   // down key
	mov A,[X+3]
	and A,[X+1]
	jnz L12
	.dbline 151
;             {
	.dbline 153
;                 // let PERT know if the "enter" button was pressed
;                 COL_PORT_DR = column_port_shadow;
	mov A,[X+5]
	mov REG[0xc],A
	.dbline 154
;                 return 1;
	mov A,1
	xjmp L3
L12:
	.dbline 156
L9:
	.dbline 147
	inc [X+0]
	asl [X+1]
L11:
	.dbline 147
	cmp [X+0],4
	jc L8
X2:
	.dbline 157
L5:
	.dbline 139
	inc [X+2]
L7:
	.dbline 139
	cmp [X+2],5
	jc L4
X3:
	.dbline 158
;             }
;         }
;     }
;     COL_PORT_DR = column_port_shadow;
	mov A,[X+5]
	mov REG[0xc],A
	.dbline 160
;     
;     return 0;
	mov A,0
	.dbline -2
L3:
	add SP,-6
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l column_port_shadow 5 c
	.dbsym l index 4 c
	.dbsym l row 3 c
	.dbsym l col 2 c
	.dbsym l mask 1 c
	.dbsym l row_bit 0 c
	.dbend
	.dbfunc e activity_check _activity_check fc
;           last -> X-5
;           this -> X-4
_activity_check::
	.dbline -1
	push X
	mov X,SP
	.dbline 179
; }
; 
; ///////////////////////////////////////////////////////////////////////////////
; //
; //  Function:    activity_check
; //
; //!  Description: Check for POT activity
; //!
; //!  Inputs:      
; //!               - this - Current POT value 
; //!               - last - Previous POT value
; //!
; //!  Returns:     
; //!               - 0 - No activity
; //!               - 1 - Activity
; //!
; ///////////////////////////////////////////////////////////////////////////////
; UINT8 activity_check(UINT8 this, UINT8 last)
; {
	.dbline 180
;     if(this > last)
	mov A,[X-5]
	cmp A,[X-4]
	jnc L15
X5:
	.dbline 181
;     {
	.dbline 182
;         if((this - last) > DEADBAND)
	mov A,[X-4]
	sub A,[X-5]
	mov [__r0],A
	mov A,10
	cmp A,[__r0]
	jnc L16
X6:
	.dbline 183
;         {
	.dbline 184
;             return(1);
	mov A,1
	xjmp L14
X4:
	.dbline 186
;         }
;     }
L15:
	.dbline 188
;     else
;     {
	.dbline 189
;         if((last - this) > DEADBAND)
	mov A,[X-5]
	sub A,[X-4]
	mov [__r0],A
	mov A,10
	cmp A,[__r0]
	jnc L19
X7:
	.dbline 190
;         {
	.dbline 191
;             return(1);
	mov A,1
	xjmp L14
L19:
	.dbline 193
;         }
;     }
L16:
	.dbline 194
;     return(0);
	mov A,0
	.dbline -2
L14:
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l last -5 c
	.dbsym l this -4 c
	.dbend
	.dbfunc e do_leds _do_leds fV
_do_leds::
	.dbline -1
	.dbline 209
; }
; 
; ///////////////////////////////////////////////////////////////////////////////
; //
; //  Function:    do_leds
; //
; //!  Description: Increment and display activity LED's for TX/RX
; //!
; //!  Inputs:      Void 
; //!
; //!  Returns:     Void
; //!
; ///////////////////////////////////////////////////////////////////////////////
; void do_leds(void)
; {
	.dbline 210
;     led_index++;
	inc [_led_index]
	.dbline 211
;     if(led_index >= sizeof(LEDpattern))
	cmp [_led_index],14
	jc L22
X8:
	.dbline 212
;     {
	.dbline 213
;         led_index = 0;
	mov [_led_index],0
	.dbline 214
;     }
L22:
	.dbline 216
;     // light the LED's    
;     COL_PORT_DR = LEDpattern[led_index];
	mov [__r1],[_led_index]
	mov [__r0],0
	add [__r1],<_LEDpattern
	adc [__r0],>_LEDpattern
	mov A,[__r0]
	push X
	mov X,[__r1]
	romx
	pop X
	mov REG[0xc],A
	.dbline -2
	.dbline 217
; }
L21:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e bind_pressed _bind_pressed fc
; led_port_shadow -> X+0
_bind_pressed::
	.dbline -1
	push X
	mov X,SP
	add SP,1
	.dbline 234
; 
; ///////////////////////////////////////////////////////////////////////////////
; //
; //   Function:    bind_pressed
; //
; //!  Description: Check to see if the bind button is pressed.  If bind button 
; //!               is pressed, there is a 20msec delay for the button release
; //!
; //!  Inputs:      Void
; //!
; //!  Returns:     
; //!               - 1 - Bind button pressed           
; //!               - 0 - Bind button not pressed
; //!
; ///////////////////////////////////////////////////////////////////////////////
; UINT8 bind_pressed(void)
; {
	.dbline 237
;     UINT8  led_port_shadow;
; 
;     led_port_shadow = LED_PORT_DR;        
	mov A,REG[0x10]
	mov [X+0],A
	.dbline 238
;     if(led_port_shadow &= BUTTON_BIND)
	mov A,[X+0]
	and A,1
	mov [X+0],A
	cmp A,0
	jz L25
	.dbline 239
;     {
	.dbline 241
;         // clear the button
;         led_port_shadow &= ~BUTTON_BIND; 
	and [X+0],-2
	xjmp L28
L27:
	.dbline 245
	.dbline 247
	and [X+0],-2
	.dbline 248
	mov A,[X+0]
	mov REG[0x10],A
	.dbline 251
	mov A,0
	push A
	mov A,20
	push A
	xcall _timer_delay_msec
	add SP,-2
	.dbline 252
L28:
	.dbline 244
;         
;         // wait for the button to be released
;         while( LED_PORT_DR &= BUTTON_BIND )
	mov A,REG[0x10]
	and A,1
	mov REG[0x10],A
	cmp A,0
	jnz L27
	.dbline 254
;         {
;             // clear the button
;             led_port_shadow &= ~BUTTON_BIND; 
;             LED_PORT_DR = led_port_shadow;
;             
;             // wait to check for the button release
;             timer_delay_msec( 20 );     
;         }
;         // clear the button
;         led_port_shadow &= ~BUTTON_BIND;                  
	and [X+0],-2
	.dbline 255
;         LED_PORT_DR = led_port_shadow;
	mov A,[X+0]
	mov REG[0x10],A
	.dbline 256
;         return 1;
	mov A,1
	xjmp L24
L25:
	.dbline 258
;     }
;     return 0;
	mov A,0
	.dbline -2
L24:
	add SP,-1
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l led_port_shadow 0 c
	.dbend
	.dbfunc e set_bind_led _set_bind_led fV
; led_port_shadow -> X+0
;          state -> X-4
_set_bind_led::
	.dbline -1
	push X
	mov X,SP
	add SP,1
	.dbline 274
; }
; 
; ///////////////////////////////////////////////////////////////////////////////
; //
; //   Function:    set_bind_led
; //
; //!  Description: Turn the bind LED on or off
; //!
; //!  Inputs:      
; //!               - state - ON or OFF.
; //!
; //!  Returns:     Void
; //!
; ///////////////////////////////////////////////////////////////////////////////
; void set_bind_led(UINT8 state)
; {
	.dbline 277
;     UINT8  led_port_shadow;
; 
;     led_port_shadow = LED_PORT_DR;        
	mov A,REG[0x10]
	mov [X+0],A
	.dbline 278
;     if( state == ON )
	cmp [X-4],1
	jnz L31
	.dbline 279
;     {
	.dbline 281
;         // clear the button
;         led_port_shadow &= ~BUTTON_BIND; 
	and [X+0],-2
	.dbline 284
; 
;         // turn the LED on
;         LED_PORT_DR = led_port_shadow & ~BIND_LED;
	mov A,[X+0]
	and A,-3
	mov REG[0x10],A
	.dbline 285
;     }
	xjmp L32
L31:
	.dbline 287
	.dbline 289
	and [X+0],-2
	.dbline 292
	mov A,[X+0]
	or A,2
	mov REG[0x10],A
	.dbline 293
L32:
	.dbline -2
	.dbline 294
;     else  // turn it off
;     {
;         // clear the button
;         led_port_shadow &= ~BUTTON_BIND; 
; 
;         // turn off the LED
;         LED_PORT_DR = led_port_shadow | BIND_LED;
;     }
; }  
L30:
	add SP,-1
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l led_port_shadow 0 c
	.dbsym l state -4 c
	.dbend
	.dbfunc e set_connect_led _set_connect_led fV
; led_port_shadow -> X+0
;          state -> X-4
_set_connect_led::
	.dbline -1
	push X
	mov X,SP
	add SP,1
	.dbline 309
; 
; ///////////////////////////////////////////////////////////////////////////////
; //
; //  Function:    set_connect_led
; //
; //!  Description: Turn the connect LED on or off
; //!
; //!  Inputs:      
; //!               - state - ON or OFF.
; //!
; //!  Returns:     Void
; //!
; ///////////////////////////////////////////////////////////////////////////////
; void set_connect_led(UINT8 state)
; {
	.dbline 312
;     UINT8  led_port_shadow;
; 
;     led_port_shadow = LED_PORT_DR;        
	mov A,REG[0x10]
	mov [X+0],A
	.dbline 313
;     if( state == ON )
	cmp [X-4],1
	jnz L34
	.dbline 314
;     {
	.dbline 316
;         // clear the button
;         led_port_shadow &= ~BUTTON_CONNECT; 
	and [X+0],-5
	.dbline 319
; 
;         // turn the LED on
;         LED_PORT_DR = led_port_shadow & ~CONNECT_LED;
	mov A,[X+0]
	and A,-9
	mov REG[0x10],A
	.dbline 320
;     }
	xjmp L35
L34:
	.dbline 322
	.dbline 324
	and [X+0],-5
	.dbline 327
	mov A,[X+0]
	or A,8
	mov REG[0x10],A
	.dbline 328
L35:
	.dbline -2
	.dbline 329
;     else  // turn it off
;     {
;         // clear the button
;         led_port_shadow &= ~BUTTON_CONNECT; 
; 
;         // turn off the LED
;         LED_PORT_DR = led_port_shadow | CONNECT_LED;
;     }
; } 
L33:
	add SP,-1
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l led_port_shadow 0 c
	.dbsym l state -4 c
	.dbend
	.area bss(ram, con, rel)
	.dbfile ./pdc9075.c
_led_index:
	.blkb 1
	.dbsym s led_index _led_index c
