	.module protocol.c
	.area data(ram, con, rel)
_protocol_device_type::
	.blkb 1
	.area idata
	.byte 2
	.area data(ram, con, rel)
	.dbfile ./protocol.c
	.dbsym e protocol_device_type _protocol_device_type c
_tx_data_toggle::
	.blkb 1
	.area idata
	.byte 1
	.area data(ram, con, rel)
	.dbfile ./protocol.c
	.dbsym e tx_data_toggle _tx_data_toggle c
_rx_data_toggle::
	.blkb 1
	.area idata
	.byte 1
	.area data(ram, con, rel)
	.dbfile ./protocol.c
	.dbsym e rx_data_toggle _rx_data_toggle c
	.area text(rom, con, rel)
	.dbfile ./protocol.c
	.dbfunc e protocol_get_tx_pkt _protocol_get_tx_pkt fpV
_protocol_get_tx_pkt::
	.dbline -1
	.dbline 101
; //--------------------------------------------------------------------------
; //! \file
; //!
; //! Collection of routines which support the WSUB LS Protocol for 
; //! HID and HID like devices
; //!
; //--------------------------------------------------------------------------
; // $Archive: /WirelessUSB/LS/Firmware/LS DVK/PSoC/Radio/protocol.c $
; // $Modtime: 3/04/04 2:46p $
; // $Revision: 1.4 $
; //--------------------------------------------------------------------------
; //
; // Copyright 2003-2004, Cypress Semiconductor Corporation.
; //
; // This software is owned by Cypress Semiconductor Corporation (Cypress)
; // and is protected by and subject to worldwide patent protection (United
; // States and foreign), United States copyright laws and international 
; // treaty provisions. Cypress hereby grants to licensee a personal, 
; // non-exclusive, non-transferable license to copy, use, modify, create 
; // derivative works of, and compile the Cypress Source Code and derivative 
; // works for the sole purpose of creating custom software in support of 
; // licensee product to be used only in conjunction with a Cypress integrated 
; // circuit as specified in the applicable agreement. Any reproduction, 
; // modification, translation, compilation, or representation of this 
; // software except as specified above is prohibited without the express 
; // written permission of Cypress.
; //
; // Disclaimer: CYPRESS MAKES NO WARRANTY OF ANY KIND,EXPRESS OR IMPLIED, 
; // WITH REGARD TO THIS MATERIAL, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
; // WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
; // Cypress reserves the right to make changes without further notice to the
; // materials described herein. Cypress does not assume any liability arising
; // out of the application or use of any product or circuit described herein.
; // Cypress does not authorize its products for use as critical components in
; // life-support systems where a malfunction or failure may reasonably be
; // expected to result in significant injury to the user. The inclusion of
; // Cypress product in a life-support systems application implies that the
; // manufacturer assumes all risk of such use and in doing so indemnifies
; // Cypress against all charges.
; //
; // Use may be limited by and subject to the applicable Cypress software
; // license agreement.
; //
; //--------------------------------------------------------------------------
; 
; //--------------------------------------
; // Included files
; //--------------------------------------
; #include "protocol.h"
; #ifdef BIND_BASIC
; #include "basic_bind.h"
; #else
; #include "bind.h"
; #endif // BIND_BASIC
; #include "radio.h"
; 
; 
; //--------------------------------------
; // Local Definitions and Types
; //--------------------------------------
; //! State that the bind is in
; extern UINT8 bind_mode;
; 
; //! To set up the device ID when generating a transmit packet
; UINT8 protocol_device_type = DEVICE_TYPE;
; 
; //! Transmit data toggle
; UINT8  tx_data_toggle      = 1;  
; 
; //! Receive data toggle
; UINT8  rx_data_toggle      = 1; 
; 
; //! Receive packet
; LS_RX_PACKET rx_packet;
; 
; //! Transmit packet
; LS_TX_PACKET tx_packet;
; 
; //! Channel valid array for data packets
; UINT8 channel_valid[LS_RX_PACKET_LEN];
; 
; // Length (bytes) of receive data.  Mainly used in protocol_send_packet(), 
; // protocol_get_rx_packet_length(), and protocol_verify_packet()
; extern UINT8 rx_data_length;
; 
; //! For accessing and formatting data packets
; SYS_PARAMETERS sys_params;
; 
; ///////////////////////////////////////////////////////////////////////////////
; //
; //  Function:    protocol_get_tx_pkt
; //
; //!  Description: Returns a pointer to the radio transmit packet 
; //!
; //!  Inputs:      Void
; //!
; //!  Returns:     Void *
; //!
; ///////////////////////////////////////////////////////////////////////////////
; void * protocol_get_tx_pkt(void)
; {
	.dbline 102
;     return &tx_packet.data.app_packet;
	mov [__r1],<_tx_packet+1
	mov [__r0],>_tx_packet+1
	.dbline -2
L25:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e protocol_get_rx_pkt _protocol_get_rx_pkt fpV
_protocol_get_rx_pkt::
	.dbline -1
	.dbline 118
; }
; 
; 
; ///////////////////////////////////////////////////////////////////////////////
; //
; //  Function:    protocol_get_rx_pkt
; //
; //!  Description: Returns a pointer to the radio receive packet 
; //!
; //!  Inputs:      Void
; //!
; //!  Returns:     Void *
; //!
; ///////////////////////////////////////////////////////////////////////////////
; void * protocol_get_rx_pkt(void)
; {
	.dbline 119
;     return &rx_packet.data.app_packet;
	mov [__r1],<_rx_packet+1
	mov [__r0],>_rx_packet+1
	.dbline -2
L27:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e protocol_init _protocol_init fc
_protocol_init::
	.dbline -1
	.dbline 138
; }
; 
; 
; ///////////////////////////////////////////////////////////////////////////////
; //
; //  Function:    protocol_init
; //
; //!  Description: Sets up first byte of transmit data packet, and reads nvram.
; //!               Gets or initializes, if necessary, device parameters.  Initializes 
; //!               the LS Radio and bind protocol
; //!
; //!  Inputs:      Void
; //!
; //!  Returns:     
; //!               - LS_STATUS_SUCCESS - Successful initialization
; //!
; ///////////////////////////////////////////////////////////////////////////////
; UINT8 protocol_init()
; {
	.dbline 139
;     tx_packet.first.byte = 0x50;    // Data packet
	mov [_tx_packet],80
	.dbline 140
;     protocol_device_type = DEVICE_TYPE;
	mov [_protocol_device_type],2
	.dbline 143
; 
;     // get nvram
;     NVRAM_READ( &sys_params, sizeof(sys_params) );
	mov A,6
	push A
	mov A,>_sys_params
	push A
	mov A,<_sys_params
	push A
	mov A,-6
	push A
	xcall _flash_read_lite
	add SP,-4
	.dbline 146
; 
;     // check for uninitialized parameters
;     if (sys_params.network_id.signature != SIGNATURE_BYTE)
	cmp [_sys_params+5],-112
	jz L30
	.dbline 147
;     {
	.dbline 150
;         // set channel and pn_code to a value that will allow the different
;         // devices to coexist and interfere less with each other
;         sys_params.network_id.signature   = SIGNATURE_BYTE;
	mov [_sys_params+5],-112
	.dbline 151
;         sys_params.network_id.channel     = DEFAULT_CHANNEL;
	mov [_sys_params],3
	.dbline 152
;         sys_params.network_id.pn_code     = DEFAULT_PN_CODE;
	mov [_sys_params+1],1
	.dbline 153
;         sys_params.network_id.seed        = DEFAULT_CHECKSUM_SEED;
	mov [_sys_params+2],0
	.dbline 154
;         sys_params.network_id.pin         = 0;
	mov [_sys_params+3],0
	.dbline 159
; 
; #ifndef PROTOCOL_1_1
;         NVRAM_WRITE( &sys_params );
; #endif // PROTOCOL_1_1
;     }
	xjmp L31
L30:
	.dbline 163
; 
; #ifdef PROTOCOL_1_1
;     else
;     {
	.dbline 166
;         // calculate channel, PN code, etc. from Bridge MID and store 
;         // values in sys_params
;         calculate_network_id();
	xcall _calculate_network_id
	.dbline 167
;     }
L31:
	.dbline 171
; #endif // PROTOCOL_1_1
; 
;     // configure the Radio
;     radio_init();
	xcall _radio_init
	.dbline 174
; 
;     // set up the channel and PN Code
;     protocol_bind_init();
	xcall _protocol_bind_init
	.dbline 176
; 
;     return LS_STATUS_SUCCESS;
	mov A,0
	.dbline -2
L29:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e calculate_network_id _calculate_network_id fV
;            pin -> X+3
;           seed -> X+2
;        pn_code -> X+1
;        channel -> X+0
_calculate_network_id::
	.dbline -1
	push X
	mov X,SP
	add SP,4
	.dbline 193
; }
; 
; #ifdef PROTOCOL_1_1
; ///////////////////////////////////////////////////////////////////////////////
; //
; //  Function:    calculate_network_id
; //
; //!  Description: Figures device parameters using algorithms to find PN code,
; //!               channel, pin, and checksum seed (based off the MID).               
; //!
; //!  Inputs:      Void
; //!
; //!  Returns:     Void
; //!
; ///////////////////////////////////////////////////////////////////////////////
; void calculate_network_id(void)
; {
	.dbline 199
;     UINT8 channel;
;     UINT8 pn_code; 
;     UINT8 seed; 
;     UINT8 pin;
; 
;     pn_code = (sys_params.bridge_mid.mid_1 << 2) + sys_params.bridge_mid.mid_2 + 
	mov [__r0],[_sys_params]
	asl [__r0]
	asl [__r0]
	mov A,[_sys_params+1]
	add [__r0],A
	mov A,[__r0]
	add A,[_sys_params+2]
	mov [X+1],A
	xjmp L41
L40:
	.dbline 202
	.dbline 203
	mov A,[X+1]
	sub A,8
	mov [X+1],A
	.dbline 204
L41:
	.dbline 201
;               sys_params.bridge_mid.mid_3;
;     while ( pn_code >= NUM_PN_CODES )
	cmp [X+1],8
	jnc L40
X0:
	.dbline 206
;     {
;         pn_code -= NUM_PN_CODES;
;     }
; 
;     channel = (sys_params.bridge_mid.mid_2 >> 2) -
	mov A,[_sys_params]
	asl A
	asl A
	asl A
	asl A
	asl A
	mov [__r0],A
	mov [__r2],[_sys_params+1]
	asr [__r2]
	asr [__r2]
	and [__r2],63
	mov A,[__r2]
	sub A,[__r0]
	add A,[_sys_params+2]
	mov [X+0],A
	xjmp L46
L45:
	.dbline 209
	.dbline 210
	mov A,[X+0]
	sub A,78
	mov [X+0],A
	.dbline 211
L46:
	.dbline 208
;               (sys_params.bridge_mid.mid_1 << 5) + sys_params.bridge_mid.mid_3;
;     while ( channel >= NUM_CHANNELS )
	cmp [X+0],78
	jnc L45
X1:
	.dbline 213
;     {
;         channel -= NUM_CHANNELS;
;     }
; 
;     pin = (((sys_params.bridge_mid.mid_1 - sys_params.bridge_mid.mid_2) & 
	mov A,[_sys_params]
	sub A,[_sys_params+1]
	and A,3
	add A,2
	mov [X+3],A
	.dbline 216
;             PIN_MASK) + MIN_PIN);
; 
;     seed = ((sys_params.bridge_mid.mid_2 >> 6)) + sys_params.bridge_mid.mid_1 + 
	mov A,[_sys_params+1]
	asr A
	asr A
	asr A
	asr A
	asr A
	asr A
	and A,3
	mov [__r0],A
	mov A,[_sys_params]
	add [__r0],A
	mov A,[__r0]
	add A,[_sys_params+2]
	mov [X+2],A
	.dbline 219
;            sys_params.bridge_mid.mid_3; 
; 
;     sys_params.network_id.channel         = channel;
	mov A,[X+0]
	mov [_sys_params],A
	.dbline 220
;     sys_params.network_id.pn_code         = pn_code;
	mov A,[X+1]
	mov [_sys_params+1],A
	.dbline 221
;     sys_params.network_id.seed            = seed;
	mov A,[X+2]
	mov [_sys_params+2],A
	.dbline 222
;     sys_params.network_id.pin             = pin;
	mov A,[X+3]
	mov [_sys_params+3],A
	.dbline -2
	.dbline 223
; }
L37:
	add SP,-4
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l pin 3 c
	.dbsym l seed 2 c
	.dbsym l pn_code 1 c
	.dbsym l channel 0 c
	.dbend
	.dbfunc e protocol_send_packet _protocol_send_packet fc
; rx_packet_type -> X+1
;     tx_timeout -> X+0
;    data_length -> X-4
_protocol_send_packet::
	.dbline -1
	push X
	mov X,SP
	add SP,2
	.dbline 251
; #endif // PROTOCOL_1_1
; 
; ///////////////////////////////////////////////////////////////////////////////
; //
; //  Function:    protocol_send_packet
; //
; //!  Description: Makes sure that the device is connected. If there is
; //!               no data to send, it will prepare a null packet to keep things
; //!               alive.  If there is data, a packet is prepared with actual
; //!               data.  Once the packet is prepared it is transmitted.  Once
; //!               an acknowledge (DATA/ACK or ACK) is received from the master
; //!               device, then it sends an ACK back (stripping the checksum and 
; //!               header from packet first).
; //!                 
; //!
; //!  Inputs:      
; //!               - data_length - Length of packet, 0 = send NULL packet
; //!
; //!  Returns:     
; //!               - TX_TIMEOUT_ERR - If not bound or when a timeout occurs on 
; //!                                the transmit
; //!               - INVALID_DATA   - When data_length is >= APP_TX_PACKET_SIZE 
; //!               - ACK_DATA       - If the data toggle parameter is set in the 
; //!                                receive packet
; //!               - DATA_SENT      - Data transmitted successfully
; ///////////////////////////////////////////////////////////////////////////////
; UINT8 protocol_send_packet( UINT8 data_length )   // Two Way
; {
	.dbline 259
;     UINT8  tx_timeout;   
;     UINT8  rx_packet_type;
; 
; #ifdef RADIO_SLEEP_ENABLED
;     radio_wakeup();
; #endif
; 
;     if (bind_mode != CONNECTED_STATE)
	cmp [_bind_mode],2
	jz L55
	.dbline 260
;     {
	.dbline 261
;         protocol_reconnect();
	xcall _protocol_reconnect
	.dbline 262
;         return TX_TIMEOUT_ERR;
	mov A,5
	xjmp L54
L55:
	.dbline 265
;     }
; 
;     tx_packet.first.byte = 0;           // clear the header byte
	mov [_tx_packet],0
	.dbline 268
; 
;     // send a Null Packet to poll for back channel data or as a keep alive packet...
;     if (data_length == 0)
	cmp [X-4],0
	jnz L57
	.dbline 269
;     {
	.dbline 270
;         tx_packet.null.hdr.type   = NULL_PACKET;
	mov A,[_tx_packet]
	and A,15
	or A,112
	mov [_tx_packet],A
	.dbline 274
; #ifdef NULL_PACKET_DATA
;         tx_packet.null.hdr.fill   = (tx_packet.data.app_packet[0] & 0x03);
; #else
;         tx_packet.null.hdr.fill = 0;
	and [_tx_packet],-13
	.dbline 277
; #endif
; 
;         tx_packet.null.hdr.dev_id  = (protocol_device_type & 0x01);
	mov A,[_protocol_device_type]
	and A,1
	asl A
	and A,2
	mov [__r0],A
	mov A,[_tx_packet]
	and A,-3
	or A,[__r0]
	mov [_tx_packet],A
	.dbline 279
; 
;         tx_packet.null.hdr.parity = protocol_gen_parity(tx_packet.first.byte);
	mov A,[_tx_packet]
	push A
	xcall _protocol_gen_parity
	add SP,-1
	and A,1
	mov [__r0],A
	mov A,[_tx_packet]
	and A,-2
	or A,[__r0]
	mov [_tx_packet],A
	.dbline 280
;         data_length = NULL_LEN;
	mov [X-4],1
	.dbline 287
; 
; #ifdef CHECKSUM_ALL_PACKETS
;         tx_packet.data.app_packet[0] = 
;         protocol_calc_ck_sum((UINT8 *)&tx_packet, 1, 
;                              sys_params.network_id.seed );
; #endif        
;     }
	xjmp L58
L57:
	.dbline 289
;     // setup for a Data Packet and bump the data toggle
;     else if (data_length < APP_TX_PACKET_SIZE + 1)
	cmp [X-4],4
	jnc L59
X3:
	.dbline 290
;     {
	.dbline 291
;         tx_packet.data.hdr.type    = DATA_PACKET;
	mov A,[_tx_packet]
	and A,15
	or A,64
	mov [_tx_packet],A
	.dbline 292
;         tx_packet.data.hdr.dev_id  = (protocol_device_type & 0x01);
	mov A,[_protocol_device_type]
	and A,1
	asl A
	and A,2
	mov [__r0],A
	mov A,[_tx_packet]
	and A,-3
	or A,[__r0]
	mov [_tx_packet],A
	.dbline 293
;         tx_packet.data.hdr.dt_data = tx_data_toggle;
	mov A,[_tx_data_toggle]
	and A,1
	asl A
	asl A
	and A,4
	mov [__r0],A
	mov A,[_tx_packet]
	and A,-5
	or A,[__r0]
	mov [_tx_packet],A
	.dbline 294
;         tx_packet.data.hdr.parity  = protocol_gen_parity(tx_packet.first.byte);
	mov A,[_tx_packet]
	push A
	xcall _protocol_gen_parity
	and A,1
	mov [__r0],A
	mov A,[_tx_packet]
	and A,-2
	or A,[__r0]
	mov [_tx_packet],A
	.dbline 297
; 
;         // calculate check sum
;         tx_packet.data.app_packet[data_length] = 
	mov A,[_sys_params+2]
	push A
	mov A,[X-4]
	add A,1
	push A
	mov A,>_tx_packet
	push A
	mov A,<_tx_packet
	push A
	xcall _protocol_calc_ck_sum
	add SP,-5
	mov [__r0],A
	mov A,[X-4]
	mov [__r3],A
	mov [__r2],0
	add [__r3],<_tx_packet+1
	adc [__r2],>_tx_packet+1
	mov A,[__r0]
	mvi [__r3],A
	.dbline 301
;             protocol_calc_ck_sum((UINT8 *)&tx_packet, data_length + 1, 
;                                  sys_params.network_id.seed);
; 
;         data_length += 2;   // length = header + data + checksum
	add [X-4],2
	.dbline 302
;     }
	xjmp L60
L59:
	.dbline 304
;     else
;     {
	.dbline 305
;         return( INVALID_DATA );   
	mov A,43
	xjmp L54
L60:
L58:
	.dbline 315
;     }
; 
;     // setup radio_transmit mode, give more time to settle
;     //radio_set_channel(sys_params.network_id.channel);
; 
;     // initialize loop control
;     //rx_packet_type = NO_PACKET;
; 
;     //loop until ACK radio_received or retries exhausted
;     for (tx_timeout = 0; tx_timeout < TX_TIMEOUT; tx_timeout++)
	mov [X+0],0
	xjmp L66
L63:
	.dbline 316
;     {
	.dbline 318
;         // send the packet
;         radio_transmit(data_length, (UINT8 *)&tx_packet);
	mov A,>_tx_packet
	push A
	mov A,<_tx_packet
	push A
	mov A,[X-4]
	push A
	xcall _radio_transmit
	.dbline 332
; 
; #ifdef RADIO_SLEEP_ENABLED        
;         // Power Savings Initiative
;         // do not immediately switch into RX mode...
;         TIMER_DELAY_50_USEC();
;         TIMER_DELAY_50_USEC();
;         //TIMER_DELAY_50_USEC();
;         TIMER_DELAY_10_USEC();
;         TIMER_DELAY_10_USEC();
; #endif
; 
;         // get an ACK 
;         //if(radio_receive(ACK_TIMEOUT) > 0)
;         if (radio_receive(LS_RX_PACKET_LEN, (UINT8 *)&rx_packet, (UINT8 *)&channel_valid, ACK_TIMEOUT) > 0)
	mov A,0
	push A
	mov A,-1
	push A
	mov A,>_channel_valid
	push A
	mov A,<_channel_valid
	push A
	mov A,>_rx_packet
	push A
	mov A,<_rx_packet
	push A
	mov A,6
	push A
	xcall _radio_receive
	add SP,-10
	mov [__r0],A
	mov A,0
	cmp A,[__r0]
	jnc L67
X4:
	.dbline 333
;         {
	.dbline 334
;             rx_packet_type = protocol_verify_packet();
	xcall _protocol_verify_packet
	mov [X+1],A
	.dbline 335
;         }
L67:
	.dbline 337
; 
;         if (rx_packet_type == DATA_ACK_PACKET )
	cmp [X+1],6
	jnz L69
	.dbline 338
;         {
	.dbline 343
; #ifdef DATA_ACK_FILTER_VALUE
;             if ( rx_packet.ack_data.hdr.flag == GOOD_ACK &&
;                  rx_packet.data.app_packet[0] == DATA_ACK_FILTER_VALUE )
; #else
;             if ( rx_packet.ack_data.hdr.flag == GOOD_ACK )
	mov A,[_rx_packet]
	asr A
	asr A
	asr A
	and A,1
	cmp A,1
	jnz L70
	.dbline 345
; #endif
;             {
	.dbline 385
; #ifdef BACK_CHANNEL_DATA  
;                 if (rx_packet.ack_data.hdr.flag != GOOD_ACK)                // bad ACK, retransmit packet
;                 {
;                     //rx_packet_type = NO_PACKET;
;                     continue;
;                 }
;                 else if (tx_packet.data.hdr.type == DATA_PACKET)
;                 {
;                     if ((tx_data_toggle & 0x01) != rx_packet.ack_data.hdr.dt_ack)    // bad data toggle, retransmit packet
;                     {
;                         //rx_packet_type = NO_PACKET;
;                         continue;
;                     }
;                     else
;                     {
;                         // flip the data toggle bit to signal an acknowledged packet
;                         // transmission
;                         tx_data_toggle++;    
;                     }
;                 }
; 
;                 rx_data_length -= 2;    // strip header and checksum from length
; 
;                 protocol_send_ack();        // send ACK in response to ACK/Data Packet
; 
; #ifdef RADIO_SLEEP_ENABLED
;                 radio_sleep();
; #endif
; 
;                 if (rx_packet.ack_data.hdr.dt_data == (rx_data_toggle & 0x01))
;                 {
;                     rx_data_toggle++;
;                     return( ACK_DATA );    
;                 }
;                 else
;                 {
;                     return( DATA_SENT );
;                 }
; #endif
;             }
	.dbline 386
;         }
	xjmp L70
L69:
	.dbline 387
;         else if (rx_packet_type == ACK_PACKET)
	cmp [X+1],5
	jnz L73
	.dbline 388
;         {
	.dbline 389
;             if ( (rx_packet.ack.hdr.flag == GOOD_ACK) && (rx_data_length == ACK_LEN) && 
	mov A,[_rx_packet]
	asr A
	asr A
	asr A
	and A,1
	cmp A,1
	jnz L74
	cmp [_rx_data_length],1
	jnz L74
	mov A,[_protocol_device_type]
	and A,1
	mov [__r0],A
	mov [__r2],[_rx_packet]
	asr [__r2]
	asr [__r2]
	and [__r2],1
	mov A,[__r2]
	cmp A,[__r0]
	jnz L74
	mov A,[_tx_packet]
	asr A
	asr A
	asr A
	asr A
	and A,15
	cmp A,7
	jz L78
	mov A,[_tx_data_toggle]
	and A,1
	mov [__r0],A
	mov [__r2],[_rx_packet]
	and F,-5
	rrc [__r2]
	and [__r2],1
	mov A,[__r2]
	cmp A,[__r0]
	jz L77
L78:
	mov A,[_tx_packet]
	asr A
	asr A
	asr A
	asr A
	and A,15
	cmp A,7
	jnz L74
L77:
	.dbline 395
;                  ((rx_packet.ack.hdr.dev_id & 0x01) == 
;                   (protocol_device_type & 0x01)) &&
;                  (((tx_packet.null.hdr.type != NULL_PACKET) &&
;                    (rx_packet.ack.hdr.dt_ack == (tx_data_toggle & 0x01))) || 
;                   (tx_packet.null.hdr.type == NULL_PACKET)) )
;             {
	.dbline 400
; #ifdef RADIO_SLEEP_ENABLED
;                 radio_sleep();
; #endif
; 
;                 if (tx_packet.null.hdr.type != NULL_PACKET)
	mov A,[_tx_packet]
	asr A
	asr A
	asr A
	asr A
	and A,15
	cmp A,7
	jz L79
	.dbline 401
;                 {
	.dbline 404
;                     // flip the data toggle bit to signal an 
;                     // acknowledged packet transmission
;                     tx_data_toggle++;    
	inc [_tx_data_toggle]
	.dbline 405
;                 }
L79:
	.dbline 407
; 
;                 return( DATA_SENT );
	mov A,41
	xjmp L54
X2:
	.dbline 409
;             }
;         }
L73:
	.dbline 411
;         else
;         {
	.dbline 415
; #ifdef ACK_BACKOFF_DELAY
;             ACK_BACKOFF_DELAY();
; #endif
;         }
L74:
L70:
	.dbline 416
L64:
	.dbline 315
	inc [X+0]
L66:
	.dbline 315
	cmp [X+0],5
	jc L63
X5:
	.dbline 418
;     } // for()
; 
;     protocol_reconnect();
	xcall _protocol_reconnect
	.dbline 424
;     //radio_idle();
; #ifdef RADIO_SLEEP_ENABLED
;     radio_sleep();
; #endif
; 
;     return( TX_TIMEOUT_ERR );   
	mov A,5
	.dbline -2
L54:
	add SP,-2
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l rx_packet_type 1 c
	.dbsym l tx_timeout 0 c
	.dbsym l data_length -4 c
	.dbend
	.dbfunc e protocol_calc_ck_sum _protocol_calc_ck_sum fc
;       checksum -> X+0
;           seed -> X-7
;            len -> X-6
;           data -> X-5
_protocol_calc_ck_sum::
	.dbline -1
	push X
	mov X,SP
	add SP,1
	.dbline 464
; }
; 
; 
; #ifdef BACK_CHANNEL_DATA
; ///////////////////////////////////////////////////////////////////////////////
; //
; //  Function:    protocol_get_rx_packet_length
; //
; //!  Description: Returns the length of the data that is being received
; //!
; //!  Inputs:      Void
; //!
; //!  Returns:     
; //!               - rx_data_length - Length of receive packet
; //!
; ///////////////////////////////////////////////////////////////////////////////
; UINT8 protocol_get_rx_packet_length(void)
; {
;     return rx_data_length;
; }
; #endif // BACK_CHANNEL_DATA
; 
; 
; ///////////////////////////////////////////////////////////////////////////////
; //
; //  Function:    protocol_calc_ck_sum
; //
; //!  Description: Calculate Packet Checksum
; //!
; //!  Inputs:      
; //!               - *data - Packet pointer
; //!               - len - Length of packet
; //!               - seed - Checksum seed
; //!
; //!  Returns:     
; //!               - checksum - Checksum calculated from data
; //!
; ///////////////////////////////////////////////////////////////////////////////
; UINT8 protocol_calc_ck_sum(UINT8 *data, UINT8 len, UINT8 seed)
; {
	.dbline 467
;     UINT8 checksum;
; 
;     for (checksum = seed; len > 0; len--, data++)
	mov A,[X-7]
	mov [X+0],A
	xjmp L85
L82:
	.dbline 468
	.dbline 469
	mov A,[X-4]
	mov [__r1],A
	mvi A,[__r1]
	mov [__r0],A
	mov A,[X+0]
	xor A,[__r0]
	mov [X+0],A
	.dbline 470
L83:
	.dbline 467
	dec [X-6]
	inc [X-4]
	adc [X-5],0
L85:
	.dbline 467
	mov A,0
	cmp A,[X-6]
	jc L82
X6:
	.dbline 471
;     {
;         checksum ^= *data;
;     }        
;     return(checksum);
	mov A,[X+0]
	.dbline -2
L81:
	add SP,-1
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l checksum 0 c
	.dbsym l seed -7 c
	.dbsym l len -6 c
	.dbsym l data -5 pc
	.dbend
	.dbfunc e protocol_gen_parity _protocol_gen_parity fc
;          count -> X+0
;           data -> X-4
_protocol_gen_parity::
	.dbline -1
	push X
	mov X,SP
	add SP,1
	.dbline 489
; }
; 
; ///////////////////////////////////////////////////////////////////////////////
; //
; //  Function:    protocol_gen_parity
; //
; //!  Description: Calculate odd parity for a byte of data
; //!
; //!  Inputs:      
; //!               - data - data byte
; //!
; //!  Returns:     
; //!               - 1 - even number of ones
; //!               - 0 - odd number of ones
; //!
; ///////////////////////////////////////////////////////////////////////////////
; UINT8 protocol_gen_parity(UINT8 data)
; {
	.dbline 490
;     UINT8 count = 0;
	mov [X+0],0
	.dbline 492
; 
;     for (; data; )
	xjmp L90
L87:
	.dbline 493
;     {
	.dbline 494
;         data>>=1; // shift out the parity bit...
	and F,-5
	rrc [X-4]
	.dbline 497
; 
;         // check for bits that are set
;         if (data & 0x01)
	tst [X-4],1
	jz L91
	.dbline 498
;         {
	.dbline 499
;             ++count;
	inc [X+0]
	.dbline 500
;         }
L91:
	.dbline 501
L88:
	.dbline 492
L90:
	.dbline 492
	cmp [X-4],0
	jnz L87
	.dbline 511
;     }    
; 
; 
;     // check for an odd number
;     // if( count & 0x01 )
;     //     return 0;
;     // else
;     //     return 1;
; 
;     // invert count and return
;     return((count + 1) & 0x01);
	mov A,[X+0]
	add A,1
	and A,1
	.dbline -2
L86:
	add SP,-1
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l count 0 c
	.dbsym l data -4 c
	.dbend
	.dbfunc e protocol_send_ack _protocol_send_ack fV
_protocol_send_ack::
	.dbline -1
	.dbline 527
; }
; 
; 
; ///////////////////////////////////////////////////////////////////////////////
; //
; //  Function:    protocol_send_ack
; //
; //!  Description: Formats the acknowledge packet and transmits it
; //!
; //!  Inputs:      Void
; //!
; //!  Returns:     Void
; //!
; ///////////////////////////////////////////////////////////////////////////////
; void protocol_send_ack(void)
; {
	.dbline 529
;     // create ACK packet
;     tx_packet.first.byte = 0;
	mov [_tx_packet],0
	.dbline 530
;     tx_packet.ack.hdr.type = ACK_PACKET;
	mov A,[_tx_packet]
	and A,15
	or A,80
	mov [_tx_packet],A
	.dbline 531
;     tx_packet.ack.hdr.flag = GOOD_ACK; 
	or [_tx_packet],8
	.dbline 533
; 
;     tx_packet.ack.hdr.dev_id = (protocol_device_type & 0x01);
	mov A,[_protocol_device_type]
	and A,1
	asl A
	asl A
	and A,4
	mov [__r0],A
	mov A,[_tx_packet]
	and A,-5
	or A,[__r0]
	mov [_tx_packet],A
	.dbline 536
; 
;     // the RX data toggle field is being mirrored back in the ACK
;     tx_packet.ack.hdr.dt_ack = rx_packet.data.hdr.dt_data;
	mov [__r0],[_rx_packet]
	asr [__r0]
	asr [__r0]
	and [__r0],1
	asl [__r0]
	and [__r0],2
	mov A,[_tx_packet]
	and A,-3
	or A,[__r0]
	mov [_tx_packet],A
	.dbline 538
; 
;     tx_packet.ack.hdr.parity = protocol_gen_parity(
	mov A,[_tx_packet]
	push A
	xcall _protocol_gen_parity
	and A,1
	mov [__r0],A
	mov A,[_tx_packet]
	and A,-2
	or A,[__r0]
	mov [_tx_packet],A
	.dbline 547
;                                                   (UINT8) tx_packet.first.byte );        
; 
; #ifdef CHECKSUM_ALL_PACKETS
;     tx_packet.data.app_packet[0] = 
;     protocol_calc_ck_sum((UINT8 *)&tx_packet, 1, sys_params.network_id.seed );
; #endif        
; 
;     // send the packet
;     radio_transmit( ACK_LEN, (UINT8 *)&tx_packet );    
	mov A,>_tx_packet
	push A
	mov A,<_tx_packet
	push A
	mov A,1
	push A
	xcall _radio_transmit
	add SP,-4
	.dbline -2
	.dbline 548
; }    
L93:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e protocol_verify_packet _protocol_verify_packet fc
;       checksum -> X+3
;        bad_bit -> X+2
;    packet_type -> X+1
;              i -> X+0
_protocol_verify_packet::
	.dbline -1
	push X
	mov X,SP
	add SP,4
	.dbline 569
; 
; 
; ///////////////////////////////////////////////////////////////////////////////
; //
; //  Function:    protocol_verify_packet
; //
; //!  Description: Gets packet data and makes sure the bytes are protocol 
; //!               perfect(otherwise it will return NO_PACKET).  It checks and
; //!               fixes packets with checksums  by testing each column of bits 
; //!               (See comments and comment block in code source).  It then 
; //!               compares checksums with the calculated checksum.
; //!
; //!  Inputs:      Void
; //!
; //!  Returns:     
; //!               - 0x00-0x07 - Packet type (See protocol.h for types of packets)  
; //!               - NO_PACKET - no packet or bad packet
; //!
; ///////////////////////////////////////////////////////////////////////////////
; UINT8 protocol_verify_packet(void)
; {
	.dbline 583
;     UINT8  i;
;     UINT8  packet_type;
;     UINT8  checksum;
;     UINT8  bad_bit; 
; 
; #ifdef PACKET_CORRECTION
;     UINT8  j;
;     UINT8  num_erasures;    // track # of erasures per column
;     UINT8  bad_row;
;     UINT8  bad_bit_count = 0;
; #endif // PACKET_CORRECTION
; 
;     // get the packet type, it is the upper nibble in the first byte
;     packet_type = rx_packet.ack.hdr.type;
	mov A,[_rx_packet]
	asr A
	asr A
	asr A
	asr A
	and A,15
	mov [X+1],A
	.dbline 589
; 
;     // check for perfect protocol bytes, requirement for bit correction AND
;     // blunder check the parity bit  AND 
;     // blunder check the packet type AND
;     // blunder check the data types by length
;     if ( (channel_valid[0] != 0xFF) || 
	cmp [_channel_valid],-1
	jnz L102
	mov [__r1],[_rx_data_length]
	mov [__r0],0
	add [__r1],<_channel_valid-1
	adc [__r0],>_channel_valid-1
	mvi A,[__r1]
	cmp A,-1
	jnz L102
	mov A,[_rx_packet]
	push A
	xcall _protocol_gen_parity
	add SP,-1
	mov [__r0],A
	mov A,[_rx_packet]
	and A,1
	mov [__r2],A
	mov A,[__r0]
	cmp A,[__r2]
	jnz L102
	cmp [X+1],8
	jnc L102
X7:
	cmp [X+1],6
	jnz L103
	mov A,2
	cmp A,[_rx_data_length]
	jnc L102
X8:
L103:
	cmp [X+1],5
	jnz L95
	cmp [_rx_data_length],1
	jz L95
L102:
	.dbline 596
;          (channel_valid[rx_data_length-1] != 0xFF) ||
;          ( protocol_gen_parity(rx_packet.first.byte) != 
;            (rx_packet.first.byte & 0x01)) || 
;          (packet_type >= MAX_NUM_TYPES + 1) ||
;          ( (packet_type == DATA_ACK_PACKET) && (rx_data_length <= 2) ) || 
;          (packet_type == ACK_PACKET && rx_data_length != ACK_LEN) )
;     {
	.dbline 600
;         // packet protocol bytes invalid OR
;         // bad parity in packet OR
;         // bad format in packet
;         return( NO_PACKET );
	mov A,-1
	xjmp L94
L95:
	.dbline 604
;     }
; 
;     // only check/fix packets with checksums
;     if ( packet_type == BIND_RESP ||
	cmp [X+1],0
	jz L106
	cmp [X+1],6
	jnz L104
L106:
	.dbline 606
;          packet_type == DATA_ACK_PACKET)
;     {
	.dbline 609
; 
;         // quick test for bad bits
;         bad_bit = 0xFF;
	mov [X+2],-1
	.dbline 610
;         for (i = 1; i < rx_data_length; i++)
	mov [X+0],1
	xjmp L110
L107:
	.dbline 611
	.dbline 614
	mov A,[X+0]
	mov [__r1],A
	mov [__r0],0
	add [__r1],<_channel_valid
	adc [__r0],>_channel_valid
	mvi A,[__r1]
	and [X+2],A
	.dbline 615
L108:
	.dbline 610
	inc [X+0]
L110:
	.dbline 610
	mov A,[X+0]
	cmp A,[_rx_data_length]
	jc L107
X9:
	.dbline 718
;         {
;             // AND the columns together to find
;             // bad bits
;             bad_bit &= channel_valid[i];
;         }
; 
; 
; #ifdef PACKET_CORRECTION        
;         // check for any bad bits
;         if (bad_bit != 0xFF)
;         {
;             ////////////////////////////////////////////////////////////////////
;             //
;             //  The checksum can only be used to fix packets with a single error
;             //  in a column. The checksum is always the last byte in the packet.
;             //
;             //                        0 1 2 3 4 5 6 7
;             //                       +---------------+
;             //  ChannelPacket[0]     |x|x|x|x|x|x|x|x|      First Byte 
;             //                       +---------------+
;             //                       +---------------+
;             //  ChannelValid [0]     |1|1|0|0|0|1|1|1|      0=Bad bit  
;             //                       +---------------+
;             //
;             //                       +---------------+
;             //  ChannelPacket[1]     |x|x|x|x|x|x|x|x|      Data 
;             //                       +---------------+
;             //                       +---------------+
;             //  ChannelValid [1]     |1|1|1|1|1|1|1|1|      0=Bad bit  
;             //                       +---------------+
;             //
;             //                       +---------------+
;             //  ChannelPacket[2]     |x|x|x|x|x|x|x|x|      Checksum  
;             //                       +---------------+
;             //                       +---------------+
;             //  ChannelValid [2]     |1|1|1|1|1|1|1|1|      0=Bad bit  
;             //                       +---------------+ 
;             //
;             ////////////////////////////////////////////////////////////////////             
; 
;             // process the data in the Packet by column
;             for (i = 0; 7 >= i; i++)
;             {
;                 num_erasures = 0;
; 
;                 // test for a column with a bad bit
;                 if (!(bad_bit & (1 << i)))
;                 {
;                     if ( packet_type == BIND_RESP )
;                     {
;                         checksum = BIND_SEED;
;                     }
;                     else
;                     {
;                         checksum = sys_params.network_id.seed;
;                     }
; 
;                        // Now that we have the bad column, figure out which row
;                     // has the bad bit
;                     for (j = 0; j < rx_data_length; j++)
;                     {
;                         // This is only true if bit j of channel_valid is 0, 
;                         // an invalid bit
;                         if ((channel_valid[j] & (1 << i)) == 0)
;                         {
;                             bad_row = j;
; 
;                             // Using num_erasures to tell when 2 bits in the
;                             // same column are bad, but it could be used for 
;                             // stats as well...
;                             num_erasures++;
;                             bad_bit_count++;
;                             if ( (num_erasures > 1) || (3 < bad_bit_count) )
;                             {
;                                  // discard the packet because
;                                  // we cannot recover from two
;                                  // erased bits in the same column or
;                                  // there are too many bad bits in
;                                  // general
;                                 packet_type = NO_PACKET;    
;                                 break;
;                             }
;                         }
;                         else  // good data, calculate checksum
;                         {
;                             checksum ^= *((UINT8 *) (&rx_packet.first.byte) + j);
;                         }
;                     }  // for ()
; 
;                     if (packet_type == NO_PACKET)
;                     {
;                         break;
;                     }
; 
;                     if (checksum & (1 << i))
;                     {
;                         *((UINT8 *)(&rx_packet.first.byte) + bad_row) |= (1 << i);
;                     }
;                     else
;                     {
;                         *((UINT8 *)(&rx_packet.first.byte) + bad_row) &= 
;                         ~(1 << i);
;                     }
;                 } // if ()
;             } // for()
;         } // if bad_bit != 0xFF
; #else
;         if (bad_bit != 0xFF)
	cmp [X+2],-1
	jz L111
	.dbline 719
;         {
	.dbline 720
;             return NO_PACKET;
	mov A,-1
	xjmp L94
L111:
	.dbline 726
;         }
; 
; #endif // PACKET_CORRECTION
; 
;         // compare the checksum....
;         if ( packet_type == BIND_RESP )
	cmp [X+1],0
	jnz L113
	.dbline 727
;         {
	.dbline 728
;             checksum = BIND_SEED;
	mov [X+3],0
	.dbline 729
;         }
	xjmp L114
L113:
	.dbline 731
;         else
;         {
	.dbline 732
;             checksum = sys_params.network_id.seed;
	mov A,[_sys_params+2]
	mov [X+3],A
	.dbline 733
;         }
L114:
	.dbline 735
;         // Comparing the received checksum with the calculated checksum    
;         if (*((UINT8 *) (&rx_packet.first.byte) + ((rx_data_length)-1)) != 
	mov A,[X+3]
	push A
	mov A,[_rx_data_length]
	sub A,1
	push A
	mov A,>_rx_packet
	push A
	mov A,<_rx_packet
	push A
	xcall _protocol_calc_ck_sum
	add SP,-4
	mov [__r0],A
	mov [__r3],[_rx_data_length]
	mov [__r2],0
	add [__r3],<_rx_packet-1
	adc [__r2],>_rx_packet-1
	mvi A,[__r3]
	cmp A,[__r0]
	jz L116
	.dbline 738
;             protocol_calc_ck_sum((UINT8*)&rx_packet.first.byte, 
;                                  (rx_data_length)-1, checksum ))
;         {
	.dbline 740
;             // bad packet
;             packet_type = NO_PACKET;
	mov [X+1],-1
	.dbline 741
;         }
L116:
	.dbline 743
; 
;     } // if packet_type == packet with checksum
L104:
	.dbline 745
; 
;     return(packet_type);
	mov A,[X+1]
	.dbline -2
L94:
	add SP,-4
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l checksum 3 c
	.dbsym l bad_bit 2 c
	.dbsym l packet_type 1 c
	.dbsym l i 0 c
	.dbend
	.area bss(ram, con, rel)
	.dbfile ./protocol.c
_channel_valid::
	.blkb 6
	.dbsym e channel_valid _channel_valid A[6:6]c
_tx_packet::
	.blkb 6
	.dbsym e tx_packet _tx_packet X
_rx_packet::
	.blkb 6
	.dbsym e rx_packet _rx_packet X
_sys_params::
	.blkb 6
	.dbsym e sys_params _sys_params X
