	.module radio.c
	.area data(ram, con, rel)
_rx_data_length::
	.blkb 1
	.area idata
	.byte 0
	.area data(ram, con, rel)
	.dbfile ./radio.c
	.dbsym e rx_data_length _rx_data_length c
	.area lit(rom, con, rel)
_radio_init_data::
	.byte 4,6
	.byte 6,11
	.byte 7,3
	.byte 13,1
	.byte 16,255
	.byte 25,3
	.byte 26,29
	.byte 32,'D
	.byte 35,7
	.byte 36,64
	.byte 38,192
	.byte 46,128
	.byte 51,'A
	.byte 50,'A
	.byte 56,'d
	.dbsym e radio_init_data _radio_init_data A[30:30]c
	.area text(rom, con, rel)
	.dbfile ./radio.c
	.dbfunc e radio_init _radio_init fV
;              i -> X+0
_radio_init::
	.dbline -1
	push X
	mov X,SP
	add SP,1
	.dbline 150
; ///--------------------------------------------------------------------------
; //! \file
; //!
; //!  Collection of routines to access the WirelessUSB LS Radio
; //!
; //--------------------------------------------------------------------------
; // $Archive: /WirelessUSB/LS/Firmware/LS DVK/PSoC/Radio/radio.c $
; // $Modtime: 3/11/04 3:52p $
; // $Revision: 1.5 $
; //--------------------------------------------------------------------------
; //
; // Copyright 2003-2004, Cypress Semiconductor Corporation.
; //
; // This software is owned by Cypress Semiconductor Corporation (Cypress)
; // and is protected by and subject to worldwide patent protection (United
; // States and foreign), United States copyright laws and international 
; // treaty provisions. Cypress hereby grants to licensee a personal, 
; // non-exclusive, non-transferable license to copy, use, modify, create 
; // derivative works of, and compile the Cypress Source Code and derivative 
; // works for the sole purpose of creating custom software in support of 
; // licensee product to be used only in conjunction with a Cypress integrated 
; // circuit as specified in the applicable agreement. Any reproduction, 
; // modification, translation, compilation, or representation of this 
; // software except as specified above is prohibited without the express 
; // written permission of Cypress.
; //
; // Disclaimer: CYPRESS MAKES NO WARRANTY OF ANY KIND,EXPRESS OR IMPLIED, 
; // WITH REGARD TO THIS MATERIAL, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
; // WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
; // Cypress reserves the right to make changes without further notice to the
; // materials described herein. Cypress does not assume any liability arising
; // out of the application or use of any product or circuit described herein.
; // Cypress does not authorize its products for use as critical components in
; // life-support systems where a malfunction or failure may reasonably be
; // expected to result in significant injury to the user. The inclusion of
; // Cypress product in a life-support systems application implies that the
; // manufacturer assumes all risk of such use and in doing so indemnifies
; // Cypress against all charges.
; //
; // Use may be limited by and subject to the applicable Cypress software
; // license agreement.
; //
; //--------------------------------------------------------------------------
; 
; 
; //--------------------------------------
; // Included files
; //--------------------------------------
; 
; #include "ls_config.h"
; #include "spim_1.h"
; #include "radio.h"
; 
; 
; //--------------------------------------
; // Local Definitions and Types
; //--------------------------------------
; 
; //! For deadman timeout loop in radio_transmit()
; #define DEADMAN_MAX_COUNT       200
; 
; #ifdef RADIO_NON_BLOCKING_CALLS
; #pragma interrupt_handler   radio_rx_isr
; 
; //! Mask for the 6 bit address
; #define SPI_ADDRESS_MASK    0x3F
; #define SPI_ISR_RADIO_GET(address, data)                              \
; {                                                                     \
;     RADIO_PORT &= ~N_SS;                                              \
;     SPIM_1_TX_BUFFER_REG = ((address) & SPI_ADDRESS_MASK);            \
;     while(!(SPIM_1_CONTROL_REG & SPIM_1_SPIM_SPI_COMPLETE));          \
;     SPIM_1_TX_BUFFER_REG = 0xFF;                                      \
;     while(!(SPIM_1_CONTROL_REG & SPIM_1_SPIM_SPI_COMPLETE));          \
;     RADIO_PORT |= N_SS;                                               \
;     data = SPIM_1_RX_BUFFER_REG;                                      \
; }
; 
; // These globals are set by radio_rx_isr
; //! Channel end of frame
; UINT8 channel_EOF = 0;
; 
; //! Data overflow
; UINT8 overflow = 0;
; 
; //! Length (bytes) of receive buffer
; UINT8 rx_buffer_length = 0;
; 
; //! Buffer for receive data
; UINT8 *rx_data_buffer = 0;
; 
; //! Buffer for valid receive data
; UINT8 *rx_valid_buffer = 0;
; 
; 
; #else
; //--------------------------------------
; // Local Function Declarations
; //--------------------------------------
; void radio_transmit_on(void);
; void radio_receive_on(void);
; void radio_off(void);
; #endif // RADIO_NON_BLOCKING_CALLS
; 
; // Length (bytes) of receive data.  Mainly used in radio_receive() and radio_rx_isr()
; UINT8 rx_data_length = 0;
; 
; //! Table for the data that configures the radio
; const UINT8 radio_init_data[] =
; {
;     REG_DATA_RATE, RADIO_MODE,
;     REG_SERDES_CTL, (SERDES_ENABLE | (EOF_LEN_MASK & EOF_BITS)),
;     REG_RX_INT_EN, (RX_FULL_A | RX_EOF_A),
;     REG_TX_INT_EN, (TX_EMPTY),  
;     REG_VALID_TX, 0xFF,
;     REG_THRESHOLD_LO, CHIP_ERROR_THRESHOLD,
;     REG_THRESHOLD_HI, (NUM_CHIPS - CHIP_ERROR_THRESHOLD),
;     REG_ANALOG_CTL, (AGC_RSSI_CTL | PACTL_EN),
;     REG_PA, (DEFAULT_POWER_LEVEL & PA_BIAS_MASK),
; #ifdef ADJUST_XTAL
;     REG_XTAL_ADJ, (CLOCK_DISABLE | (DEFAULT_XTL & XTAL_ADJ_MASK)),
; #else
;     REG_XTAL_ADJ, (CLOCK_DISABLE),              // disable 13MHz clock output
; #endif
;     REG_VCO_CAL, MINUS_5_PLUS_5,                 // use the laser trimmed VCO value
;     REG_AGC_CTL, AGC_OFF,                       // turn off AGC circuitry to reduce power consumption
; #ifdef RADIO_USE_RSSI
;     REG_CARRIER_DETECT, CDET,                   // force carrier detect (automatically triggers an RSSI reading)
; #endif    
;     REG_CLOCK_ENABLE, 0x41,                     // set per datasheet
;     REG_CLOCK_MANUAL, 0x41,                     // set per datasheet
;     REG_SYN_LOCK_CNT, SYNTH_SETTLE_COUNT       // time to wait for the synth to settle
; };
; 
; 
; ///////////////////////////////////////////////////////////////////////////////
; //
; //  Function:    radio_init
; //
; //!  Description: After a reset and power cycle, the crystal is given time to
; //!               settle and then it comes out of reset and then the radio is
; //!               configured
; //!
; //!  Inputs:      Void
; //!
; //!  Returns:     Void
; //!
; ///////////////////////////////////////////////////////////////////////////////
; 
; void radio_init()
; {
	.dbline 153
;     UINT8 i;
;     
;     RADIO_PORT &= ~(N_PD | N_RESET);  
	and REG[0x4],-10
	.dbline 154
;     RADIO_PORT |= N_PD; 
	or REG[0x4],1
	.dbline 155
;     TIMER_DELAY_MSEC(RADIO_WAKEUP_TIME * 2);    // crystal settle time
	mov A,0
	push A
	mov A,6
	push A
	xcall _timer_delay_msec
	add SP,-2
	.dbline 157
; 
;     spi_init();
	xcall _spi_init
	.dbline 158
;     RADIO_PORT |= (N_RESET);                // bring radio out of reset...
	or REG[0x4],8
	.dbline 161
; 
;     // load the configuration data
;     for(i = 0; i < sizeof(radio_init_data); i += 2)
	mov [X+0],0
	xjmp L5
L2:
	.dbline 162
	.dbline 163
	mov A,[X+0]
	mov [__r1],A
	mov [__r0],0
	add [__r1],<_radio_init_data+1
	adc [__r0],>_radio_init_data+1
	mov A,[__r0]
	push X
	mov X,[__r1]
	romx
	pop X
	push A
	mov A,[X+0]
	mov [__r1],A
	mov [__r0],0
	add [__r1],<_radio_init_data
	adc [__r0],>_radio_init_data
	mov A,[__r0]
	push X
	mov X,[__r1]
	romx
	pop X
	or A,-128
	push A
	xcall _spi_radio_access
	add SP,-2
	.dbline 164
L3:
	.dbline 161
	add [X+0],2
L5:
	.dbline 161
	cmp [X+0],30
	jc L2
X0:
	.dbline -2
	.dbline 165
;     {
;         spi_radio_put(radio_init_data[i] , radio_init_data[i + 1]);
;     }
;  }
L1:
	add SP,-1
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l i 0 c
	.dbend
	.dbfunc e radio_receive_on _radio_receive_on fV
_radio_receive_on::
	.dbline -1
	.dbline 182
; 
; ///////////////////////////////////////////////////////////////////////////////
; //
; //   Function:    radio_receive_on
; //
; //!  Description: Interrupts are disabled and the overflow, channel_EOF, and 
; //!               RX data length are all initialized, if RADIO_NON_BLOCKING_CALLS
; //!               is defined.  Then sets the radio up to receive.  Enables 
; //!               interrupts, if necessary
; //!
; //!  Inputs:      Void
; //!
; //!  Returns:     Void
; //!
; ///////////////////////////////////////////////////////////////////////////////
; void radio_receive_on(void)
; {
	.dbline 192
; #ifdef RADIO_NON_BLOCKING_CALLS
;     RADIO_ISR_DISABLE();
;     overflow     = 0;
;     channel_EOF   = 0;  
;     rx_data_length = 0;
; #endif // RADIO_NON_BLOCKING_CALLS
;     
;     
;     // clear old data and interrupts
;     spi_radio_get(REG_DATA_RX_A);
	mov A,-1
	push A
	mov A,9
	push A
	xcall _spi_radio_access
	add SP,-2
	.dbline 193
;     spi_radio_get(REG_RX_INT_STAT);
	mov A,-1
	push A
	mov A,8
	push A
	xcall _spi_radio_access
	.dbline 194
;     spi_radio_put(REG_CONTROL, (RX_ENABLE | AUTO_SYNTH_COUNT)); 
	mov A,-112
	push A
	mov A,-125
	push A
	xcall _spi_radio_access
	add SP,-4
	.dbline -2
	.dbline 199
;     
; #ifdef RADIO_NON_BLOCKING_CALLS
;     RADIO_ISR_ENABLE();
; #endif
; }
L7:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e radio_transmit_on _radio_transmit_on fV
_radio_transmit_on::
	.dbline -1
	.dbline 219
; 
; ///////////////////////////////////////////////////////////////////////////////
; //
; //   Function:    radio_transmit_on
; //
; //!  Description: Sets up the radio to transmit mode.  Disables interrupts if
; //!               RADIO_NON_BLOCKING_CALLS is defined.  Interrupts should 
; //!               always be disabled while transmitting packets because it is
; //!               polled driven. The device knows when it will transmit a packet.
; //!               Interrupts should only be used when receiving packets because
; //!               the device doesn't know when it receives data, thus more power
; //!               is conserved.
; //!
; //!  Inputs:      Void
; //!
; //!  Returns:     Void
; //!
; ///////////////////////////////////////////////////////////////////////////////
; void radio_transmit_on(void)
; {
	.dbline 224
; #ifdef RADIO_NON_BLOCKING_CALLS
;     RADIO_ISR_DISABLE();             // disable ISR
; #endif    
;     // enable transmit mode
;     spi_radio_put(REG_CONTROL, (TX_ENABLE | AUTO_SYNTH_COUNT)); 
	mov A,80
	push A
	mov A,-125
	push A
	xcall _spi_radio_access
	add SP,-2
	.dbline -2
	.dbline 225
; }
L8:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e radio_off _radio_off fV
_radio_off::
	.dbline -1
	.dbline 239
; 
; ///////////////////////////////////////////////////////////////////////////////
; //
; //   Function:    radio_off
; //
; //!  Description: Turns off transmit and receive modes
; //!
; //!  Inputs:      Void
; //!
; //!  Returns:     Void
; //!
; ///////////////////////////////////////////////////////////////////////////////
; void radio_off(void)
; {                                                                     
	.dbline 243
; #ifdef RADIO_NON_BLOCKING_CALLS
;     RADIO_ISR_DISABLE();                                              
; #endif
;     spi_radio_put(REG_CONTROL, 0);
	mov A,0
	push A
	mov A,-125
	push A
	xcall _spi_radio_access
	add SP,-2
	.dbline -2
	.dbline 244
; }
L9:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e radio_set_channel _radio_set_channel fV
;        channel -> X-4
_radio_set_channel::
	.dbline -1
	push X
	mov X,SP
	.dbline 263
; 
; //////////////////////////////////////////////////////////////////////////////
; //
; //   Function:    radio_set_channel
; //
; //!  Description: Sets the radio channel by passing the channel register 
; //!               (REG_CHANNEL), and a valid channel to spi_radio_put().  
; //!               CHANNEL_OFFSET is used for 2 MHz guard band. (See radio.h 
; //!               for CHANNEL_OFFSET definition) CHANNEL_MASK is to ensure
; //!               validity of channel.
; //!
; //!  Inputs:      
; //!               - channel - channel to set the radio to
; //!
; //!  Returns:     Void
; //!
; ///////////////////////////////////////////////////////////////////////////////  
; void radio_set_channel(UINT8 channel)
; {
	.dbline 264
;     spi_radio_put(REG_CHANNEL, (CHANNEL_MASK & (channel + CHANNEL_OFFSET)));
	mov A,[X-4]
	add A,2
	and A,127
	push A
	mov A,-95
	push A
	xcall _spi_radio_access
	add SP,-2
	.dbline -2
	.dbline 265
; }
L10:
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l channel -4 c
	.dbend
	.dbfunc e radio_set_pn_code _radio_set_pn_code fV
;              i -> X+0
;        pn_code -> X-5
_radio_set_pn_code::
	.dbline -1
	push X
	mov X,SP
	add SP,1
	.dbline 281
; 
; ///////////////////////////////////////////////////////////////////////////////
; //
; //   Function:    radio_set_pn_code
; //
; //!  Description: Load the PN Code. For more information on PN codes please see
; //!               the LS Theory of Operation app note.
; //!
; //!  Inputs:      
; //!               - pn_code - pointer to the 8-byte PN code
; //!
; //!  Returns:     Void
; //!
; ///////////////////////////////////////////////////////////////////////////////
; void radio_set_pn_code(const UINT8 *pn_code)
; {
	.dbline 284
;     UINT8 i;
; 
;     for(i = 0; 7 >= i; i++)
	mov [X+0],0
	xjmp L15
L12:
	.dbline 285
	.dbline 286
	mov A,[X+0]
	mov [__r1],A
	mov [__r0],0
	mov A,[X-4]
	add [__r1],A
	mov A,[X-5]
	adc [__r0],A
	mov A,[__r0]
	push X
	mov X,[__r1]
	romx
	pop X
	push A
	mov A,[X+0]
	add A,17
	or A,-128
	push A
	xcall _spi_radio_access
	add SP,-2
	.dbline 287
L13:
	.dbline 284
	inc [X+0]
L15:
	.dbline 284
	mov A,7
	cmp A,[X+0]
	jnc L12
X1:
	.dbline -2
	.dbline 288
;     {
;         spi_radio_put(REG_PN_CODE + i, *(pn_code + i));
;     }
; }
L11:
	add SP,-1
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l i 0 c
	.dbsym l pn_code -5 pc
	.dbend
	.dbfunc e radio_transmit _radio_transmit fV
;    radio_state -> X+2
;              i -> X+1
;        counter -> X+0
;      tx_buffer -> X-6
;  buffer_length -> X-4
_radio_transmit::
	.dbline -1
	push X
	mov X,SP
	add SP,3
	.dbline 309
; 
; 
; ///////////////////////////////////////////////////////////////////////////////
; //
; //   Function:    radio_transmit
; //
; //!  Description: Send a packet to the radio, one byte at a time. 
; //!               If the radio is not already in transmit mode, 
; //!               radio_transmit_on() will be called before transmitting data 
; //!               and the radio will be turned off ( radio_off() ) after the  
; //!               packet transmission is complete.
; //!
; //!  Inputs:      
; //!               - len     - length of packet
; //!               - *data   - pointer to the packet
; //!
; //!  Returns:     Void
; //!
; ///////////////////////////////////////////////////////////////////////////////
; void radio_transmit(UINT8 buffer_length, UINT8 *tx_buffer)
; {
	.dbline 314
;     UINT8 i;
;     UINT8 counter;
;     UINT8 radio_state;
; 
;     radio_state = (spi_radio_get(REG_CONTROL));
	mov A,-1
	push A
	mov A,3
	push A
	xcall _spi_radio_access
	add SP,-2
	mov [X+2],A
	.dbline 315
;     if ((radio_state & TX_ENABLE) != TX_ENABLE)
	mov A,[X+2]
	and A,64
	cmp A,64
	jz L17
	.dbline 316
;     {
	.dbline 317
;         radio_transmit_on();
	xcall _radio_transmit_on
	.dbline 318
;     }
L17:
	.dbline 319
;     i = (spi_radio_get(REG_CONTROL));
	mov A,-1
	push A
	mov A,3
	push A
	xcall _spi_radio_access
	mov [X+1],A
	.dbline 321
; 
;     spi_radio_put(REG_TX_INT_EN, TX_EMPTY);
	mov A,1
	push A
	mov A,-115
	push A
	xcall _spi_radio_access
	add SP,-4
	.dbline 323
;     // send the packet
;     for(i = 0; i < buffer_length; ++i, ++tx_buffer) 
	mov [X+1],0
	xjmp L22
L19:
	.dbline 324
;     {
	.dbline 325
;         for (counter = 0; (counter < DEADMAN_MAX_COUNT) && (!LS_IRQ_ASSERTED); 
	mov [X+0],0
	xjmp L26
L23:
	.dbline 326
L24:
	.dbline 326
	inc [X+0]
L26:
	.dbline 325
	cmp [X+0],-56
	jnc L27
X2:
	tst REG[0x4],16
	jz L23
L27:
	.dbline 328
	mov A,[X-5]
	mov [__r1],A
	mvi A,[__r1]
	push A
	mov A,-113
	push A
	xcall _spi_radio_access
	add SP,-2
	.dbline 329
L20:
	.dbline 323
	inc [X+1]
	inc [X-5]
	adc [X-6],0
L22:
	.dbline 323
	mov A,[X+1]
	cmp A,[X-4]
	jc L19
X3:
	.dbline 332
;              counter++); //dead man timeout
; 
;         spi_radio_put(REG_DATA_TX, *tx_buffer);
;     }
; 
;     // enable the EOF interrupt and disable the EMPTY interrupt
;     spi_radio_put(REG_TX_INT_EN, TX_EOF);
	mov A,2
	push A
	mov A,-115
	push A
	xcall _spi_radio_access
	add SP,-2
	.dbline 334
; 
;     TIMER_DELAY_50_USEC();
	xcall _timer_delay_50_usec
	.dbline 335
;     TIMER_DELAY_50_USEC();
	xcall _timer_delay_50_usec
	.dbline 337
;     
;     for (counter = 0; (counter < DEADMAN_MAX_COUNT) && (!LS_IRQ_ASSERTED); 
	mov [X+0],0
	xjmp L31
L28:
	.dbline 338
L29:
	.dbline 338
	inc [X+0]
L31:
	.dbline 337
	cmp [X+0],-56
	jnc L32
X4:
	tst REG[0x4],16
	jz L28
L32:
	.dbline 340
	mov A,[X+2]
	and A,64
	cmp A,64
	jz L33
	.dbline 341
	.dbline 342
	xcall _radio_off
	.dbline 343
L33:
	.dbline -2
	.dbline 344
;           counter++); //dead man timeout
; 
;     if ((radio_state & TX_ENABLE) != TX_ENABLE)
;     {
;         radio_off();
;     }
; }
L16:
	add SP,-3
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l radio_state 2 c
	.dbsym l i 1 c
	.dbsym l counter 0 c
	.dbsym l tx_buffer -6 pc
	.dbsym l buffer_length -4 c
	.dbend
	.dbfunc e radio_receive _radio_receive fc
;    radio_state -> X+3
;   loop_counter -> X+1
;     irq_source -> X+0
;        timeout -> X-10
;   valid_buffer -> X-8
;      rx_buffer -> X-6
;  buffer_length -> X-4
_radio_receive::
	.dbline -1
	push X
	mov X,SP
	add SP,4
	.dbline 373
; 
; #ifndef RADIO_NON_BLOCKING_CALLS     
; ///////////////////////////////////////////////////////////////////////////////
; //
; //  Function:    radio_receive
; //
; //!  Description: If the radio is not already in receive mode radio_receive_on()
; //!               is called.  Data is received from the radio until an end-of-
; //!               frame (EOF) interrupt is set or a timeout is reached
; //!
; //!  Inputs:      
; //!               - buffer_length - Maximum number of bytes that can be received
; //!                               before a buffer overflow occurs.
; //!               - *rx_buffer    - Pointer to the buffer to store received data.              
; //!               - *valid_buffer - Pointer to buffer to store received valid bytes.
; //!               - timeout       - Length of time to be in receive mode before timing
; //!                               out. This value is in 10us units.  Once a byte
; //!                               is received the function will not return until
; //!                               the EOF interrupt is received, or a buffer overflow
; //!                               occurs, in order to prevent the function from
; //!                               returning in the middle of receiving a packet.
; //!
; //!  Returns:     
; //!               - rx_data_length - Length of packet received 
; //!               - 0 - Otherwise
; //!
; ///////////////////////////////////////////////////////////////////////////////
; UINT8 radio_receive(UINT8 buffer_length, UINT8 *rx_buffer, UINT8 *valid_buffer, UINT16 timeout)
; {
	.dbline 376
;     UINT8  irq_source;
;     UINT8  radio_state;
;     UINT16 loop_counter = 0;
	mov [X+2],0
	mov [X+1],0
	.dbline 378
; 
;     radio_state = (spi_radio_get(REG_CONTROL));
	mov A,-1
	push A
	mov A,3
	push A
	xcall _spi_radio_access
	add SP,-2
	mov [X+3],A
	.dbline 379
;     if ((radio_state & RX_ENABLE) != RX_ENABLE)
	mov A,[X+3]
	and A,-128
	cmp A,-128
	jz L36
	.dbline 380
;     {
	.dbline 381
;         radio_receive_on();
	xcall _radio_receive_on
	.dbline 382
;     }
L36:
	.dbline 383
;     rx_data_length = 0;    
	mov [_rx_data_length],0
	xjmp L39
L38:
	.dbline 387
; 
;     // don't break out of the loop mid-packet..
;     while ((loop_counter < timeout) || (rx_data_length != 0))    
;     {
	.dbline 390
;         // poll for a Radio Module interrupt, interrupts are self clearing
;         // when the appropriate status register is read 
;         if(LS_IRQ_ASSERTED)
	tst REG[0x4],16
	jz L41
	.dbline 391
;         {   
	.dbline 393
;             // read the Radio Rx Interrupt register
;             irq_source = spi_radio_get(REG_RX_INT_STAT);
	mov A,-1
	push A
	mov A,8
	push A
	xcall _spi_radio_access
	add SP,-2
	mov [X+0],A
	.dbline 395
;             
;             if(irq_source & RX_FULL_A)
	tst [X+0],1
	jz L43
	.dbline 396
;             {
	.dbline 397
;                 *rx_buffer = spi_radio_get(REG_DATA_RX_A);
	mov A,-1
	push A
	mov A,9
	push A
	xcall _spi_radio_access
	add SP,-2
	mov [__r0],A
	mov A,[X-5]
	mov [__r3],A
	mov A,[__r0]
	mvi [__r3],A
	.dbline 400
;                 
;                 // don't read the valid register if it is all valid
;                 if( irq_source & RX_VALID_A )
	tst [X+0],8
	jz L45
	.dbline 401
;                 {
	.dbline 402
;                     *valid_buffer = 0xFF;
	mov A,[X-7]
	mov [__r1],A
	mov A,-1
	mvi [__r1],A
	.dbline 403
;                 }
	xjmp L46
L45:
	.dbline 405
;                 else
;                 {
	.dbline 406
;                     *valid_buffer = spi_radio_get(REG_VALID_RX_A);
	mov A,-1
	push A
	mov A,10
	push A
	xcall _spi_radio_access
	add SP,-2
	mov [__r0],A
	mov A,[X-7]
	mov [__r3],A
	mov A,[__r0]
	mvi [__r3],A
	.dbline 407
;                 }
L46:
	.dbline 410
;             
;                 // filter out bad bytes and don't overwrite the globals
;                 if((*valid_buffer >= 0x0F) || (rx_data_length > 0))
	mov A,[X-7]
	mov [__r1],A
	mvi A,[__r1]
	cmp A,15
	jnc L49
X5:
	mov A,0
	cmp A,[_rx_data_length]
	jnc L47
X6:
L49:
	.dbline 411
;                 {
	.dbline 412
;                     if (rx_data_length < buffer_length)
	mov A,[_rx_data_length]
	cmp A,[X-4]
	jnc L50
X7:
	.dbline 413
;                     {
	.dbline 414
;                         rx_data_length++;
	inc [_rx_data_length]
	.dbline 415
;                         loop_counter = 0;
	mov [X+2],0
	mov [X+1],0
	.dbline 423
; 
; #ifdef RADIO_CHECK_FOR_ACK        
;                         if (((data & 0xF0) == 0x50) && (rx_data_length == ACK_LEN)) 
;                         {
;                             break;
;                         }
; #endif
;                         rx_buffer++;
	inc [X-5]
	adc [X-6],0
	.dbline 424
;                         valid_buffer++;
	inc [X-7]
	adc [X-8],0
	.dbline 425
;                     }
	xjmp L51
L50:
	.dbline 427
;                     else
;                     {
	.dbline 429
;                         // buffer overflow... exit receive mode
;                         rx_data_length = 0;
	mov [_rx_data_length],0
	.dbline 430
;                         break;
	xjmp L40
L51:
	.dbline 432
;                     }
;                 }
L47:
	.dbline 433
;             }
L43:
	.dbline 435
;                 
;             if(irq_source & RX_EOF_A)
	tst [X+0],2
	jz L52
	.dbline 436
;             {               
	.dbline 437
;                 if (rx_data_length != 0)
	cmp [_rx_data_length],0
	jz L54
	.dbline 438
;                 {
	.dbline 439
;                     break;
	xjmp L40
L54:
	.dbline 441
;                 }
;             }
L52:
	.dbline 442
;             if(irq_source & RX_OVER_A)
	tst [X+0],4
	jz L42
	.dbline 443
;             {
	.dbline 444
;                 loop_counter = 0;
	mov [X+2],0
	mov [X+1],0
	.dbline 445
;             }            
	.dbline 446
;         }   //if(LS_IRQ_ASSERTED)
	xjmp L42
L41:
	.dbline 448
;         else
;         {
	.dbline 449
;             ++loop_counter;            // only increment loop_counter for each 10us delay...
	inc [X+2]
	adc [X+1],0
	.dbline 450
;             TIMER_DELAY_10_USEC();
	xcall _timer_delay_10_usec
	.dbline 451
;         }
L42:
	.dbline 452
L39:
	.dbline 386
	mov A,[X+2]
	sub A,[X-9]
	mov A,[X+1]
	sbb A,[X-10]
	jc L38
X8:
	cmp [_rx_data_length],0
	jnz L38
L40:
	.dbline 454
;     } // while(loop_counter...)    
;     
;     if ((radio_state & RX_ENABLE) != RX_ENABLE)
	mov A,[X+3]
	and A,-128
	cmp A,-128
	jz L58
	.dbline 455
;     {
	.dbline 456
;         radio_off();
	xcall _radio_off
	.dbline 457
;     }
L58:
	.dbline 459
; 
;     return rx_data_length;
	mov A,[_rx_data_length]
	.dbline -2
L35:
	add SP,-4
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l radio_state 3 c
	.dbsym l loop_counter 1 s
	.dbsym l irq_source 0 c
	.dbsym l timeout -10 s
	.dbsym l valid_buffer -8 pc
	.dbsym l rx_buffer -6 pc
	.dbsym l buffer_length -4 c
	.dbend
