	.module spi.c
	.area text(rom, con, rel)
	.dbfile ./spi.c
	.dbfunc e spi_init _spi_init fV
_spi_init::
	.dbline -1
	.dbline 93
; //--------------------------------------------------------------------------
; //! \file
; //!
; //! This module provides a radio control interface using an SPI port.
; //!
; //--------------------------------------------------------------------------
; // $Archive: /WirelessUSB/LS/Firmware/LS DVK/PSoC/Common/spi.c $
; // $Modtime: 2/12/04 12:33p $
; // $Revision: 1.4 $
; //--------------------------------------------------------------------------
; //
; // Copyright 2003-2004, Cypress Semiconductor Corporation.
; //
; // This software is owned by Cypress Semiconductor Corporation (Cypress)
; // and is protected by and subject to worldwide patent protection (United
; // States and foreign), United States copyright laws and international 
; // treaty provisions. Cypress hereby grants to licensee a personal, 
; // non-exclusive, non-transferable license to copy, use, modify, create 
; // derivative works of, and compile the Cypress Source Code and derivative 
; // works for the sole purpose of creating custom software in support of 
; // licensee product to be used only in conjunction with a Cypress integrated 
; // circuit as specified in the applicable agreement. Any reproduction, 
; // modification, translation, compilation, or representation of this 
; // software except as specified above is prohibited without the express 
; // written permission of Cypress.
; //
; // Disclaimer: CYPRESS MAKES NO WARRANTY OF ANY KIND,EXPRESS OR IMPLIED, 
; // WITH REGARD TO THIS MATERIAL, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
; // WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
; // Cypress reserves the right to make changes without further notice to the
; // materials described herein. Cypress does not assume any liability arising
; // out of the application or use of any product or circuit described herein.
; // Cypress does not authorize its products for use as critical components in
; // life-support systems where a malfunction or failure may reasonably be
; // expected to result in significant injury to the user. The inclusion of
; // Cypress product in a life-support systems application implies that the
; // manufacturer assumes all risk of such use and in doing so indemnifies
; // Cypress against all charges.
; //
; // Use may be limited by and subject to the applicable Cypress software
; // license agreement.
; //
; //--------------------------------------------------------------------------
; 
; 
; //--------------------------------------
; // Included files
; //--------------------------------------
; 
; #include "spim_1.h"
; #include "ls_config.h"
; 
; 
; //--------------------------------------
; // Local Defines and Types
; //--------------------------------------
; 
; #ifndef SPIM_MODE_0
; 
; //! MODE 0 - Leading edge latches data - pos clock
; #define SPIM_MODE_0         SPIM_1_SPIM_MODE_0
; #endif
; 
; #ifndef SPIM_MSB_FIRST
; 
; //! MSB bit transmitted/received first
; #define SPIM_MSB_FIRST      SPIM_1_SPIM_MSB_FIRST
; #endif
; 
; #ifndef SPIM_SPI_COMPLETE
; 
; //! SPI Tx/Rx cycle has completed
; #define SPIM_SPI_COMPLETE   SPIM_1_SPIM_SPI_COMPLETE
; #endif
; 
; //! Mask for the 6 bit address
; #define SPI_ADDRESS_MASK    0x3F
; 
; 
; ///////////////////////////////////////////////////////////////////////////////
; //
; //   Function:    spi_init
; //
; //!  Description: Calls the Start routine of the SPIM user module which 
; //!               configures the start bit, SPI mode, and LSB/MSB first.
; //!
; //!  Inputs:      Void
; //!
; //!  Returns:     Void
; //!
; ///////////////////////////////////////////////////////////////////////////////
; void spi_init(void)
; {
	.dbline 94
;     SPIM_1_Start(SPIM_MODE_0 | SPIM_MSB_FIRST);
	push X
	mov A,0
	xcall _SPIM_1_Start
	pop X
	.dbline -2
	.dbline 95
; }
L1:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e spi_radio_access _spi_radio_access fc
;           data -> X-5
;        address -> X-4
_spi_radio_access::
	.dbline -1
	push X
	mov X,SP
	.dbline 116
; 
; 
; ///////////////////////////////////////////////////////////////////////////////
; //
; //   Function:    spi_radio_access
; //
; //!  Description: Sets up the radio port and reads or transmits data from the
; //!               radio.  The interrupt service routine is disabled during 
; //!               that time if necessary.
; //!
; //!  Inputs:      
; //!               - address - the register for what is being accessed from the
; //!               radio. (i.e. pn code, control, crystal adjust, channel, etc.)
; //!               - data - radio attribute to either be set or found
; //!
; //!  Returns:     
; //!               - data - radio attribute (i.e. radio Manufacture ID (MID))
; //!
; ///////////////////////////////////////////////////////////////////////////////
; UINT8 spi_radio_access(UINT8 address, UINT8 data)
; {
	.dbline 124
; #ifdef RADIO_NON_BLOCKING_CALLS
;     UINT8 isr_state = GPIO_ISR_RADIO_IE_PORT;
; 
;     RADIO_ISR_DISABLE();
; #endif // RADIO_NON_BLOCKING_CALLS
; 
;     // assert the slave select
;     RADIO_PORT &= ~N_SS;
	and REG[0x4],-3
	.dbline 127
;     
;     // write the select address
;     SPIM_1_TX_BUFFER_REG = address;
	mov A,[X-4]
	mov REG[0x3d],A
L3:
	.dbline 128
L4:
	.dbline 128
;     while(!(SPIM_1_CONTROL_REG & SPIM_SPI_COMPLETE));
	tst REG[0x3f],32
	jz L3
	.dbline 131
;     
;     // read the data
;     SPIM_1_TX_BUFFER_REG = data;
	mov A,[X-5]
	mov REG[0x3d],A
L6:
	.dbline 132
L7:
	.dbline 132
;     while(!(SPIM_1_CONTROL_REG & SPIM_SPI_COMPLETE));
	tst REG[0x3f],32
	jz L6
	.dbline 135
; 
;     // deassert the slave select
;     RADIO_PORT |= N_SS;
	or REG[0x4],2
	.dbline 137
; 
;     data = SPIM_1_RX_BUFFER_REG;
	mov A,REG[0x3e]
	mov [X-5],A
	.dbline 146
; 
; #ifdef RADIO_NON_BLOCKING_CALLS
;     if( isr_state & GPIO_ISR_RADIO_INT )
;     {
;         RADIO_ISR_ENABLE();
;     }
; #endif // RADIO_NON_BLOCKING_CALLS
; 
;     return data;
	mov A,[X-5]
	.dbline -2
L2:
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l data -5 c
	.dbsym l address -4 c
	.dbend
