;;*****************************************************************************
;;*****************************************************************************
;;  FILENAME: Tick.inc
;;   Version: 2.4, Updated on 2004/10/27 at 18:26:56
;;  Generated by PSoC Designer ver 4.2  b1013 : 02 September, 2004
;;
;;  DESCRIPTION: Assembler declarations for the Timer8 user module interface
;;               for the 22/24/27/29xxx PSoC family of devices
;;-----------------------------------------------------------------------------
;;  Copyright (c) Cypress MicroSystems 2000-2004. All Rights Reserved.
;;*****************************************************************************
;;*****************************************************************************

include "m8c.inc"


;--------------------------------------------------
; Constants for Tick API's.
;--------------------------------------------------

Tick_CONTROL_REG_START_BIT:                equ 0x01    ; Control register start bit
Tick_INT_REG:                              equ 0x0e1
Tick_INT_MASK:                             equ 0x08


;--------------------------------------------------
; Constants for Tick user defined values
;--------------------------------------------------

Tick_PERIOD:                               equ 0x20
Tick_COMPARE_VALUE:                        equ 0x00


;--------------------------------------------------
; Register Address Constants for Tick
;--------------------------------------------------

Tick_COUNTER_REG:                      equ 0x2c   ; DR0 Counter register
Tick_PERIOD_REG:                       equ 0x2d   ; DR1 Period register
Tick_COMPARE_REG:                      equ 0x2e   ; DR2 CompareValue register
Tick_CONTROL_REG:                      equ 0x2f   ; Control register
Tick_FUNC_REG:                         equ 0x2c   ; Function register
Tick_INPUT_REG:                        equ 0x2d   ; Input register
Tick_OUTPUT_REG:                       equ 0x2e   ; Output register


;--------------------------------------------------
; Tick Macro 'Functions'
;--------------------------------------------------

   macro Tick_Start_M
   or    reg[Tick_CONTROL_REG],  Tick_CONTROL_REG_START_BIT
   endm

   macro Tick_Stop_M
   and   reg[Tick_CONTROL_REG], ~Tick_CONTROL_REG_START_BIT
   endm

   macro Tick_EnableInt_M
   M8C_EnableIntMask Tick_INT_REG, Tick_INT_MASK
   endm

   macro Tick_DisableInt_M
   M8C_DisableIntMask Tick_INT_REG, Tick_INT_MASK
   endm


; end of file Tick.inc
