//*****************************************************************************
//*****************************************************************************
//  FILENAME: SPI_Clk.h
//   Version: 2.4, Updated on 2004/10/27 at 18:26:56
//  Generated by PSoC Designer ver 4.2  b1013 : 02 September, 2004
//
//  DESCRIPTION: Timer8 User Module C Language interface file
//               for the 22/24/27/29xxx PSoC family of devices
//-----------------------------------------------------------------------------
//  Copyright (c) Cypress MicroSystems 2000-2004. All Rights Reserved.
//*****************************************************************************
//*****************************************************************************

#include <m8c.h>

#pragma fastcall16 SPI_Clk_EnableInt                 //                 Proxy 1
#pragma fastcall16 SPI_Clk_DisableInt                //                 Proxy 1
#pragma fastcall16 SPI_Clk_Start                     //                 Proxy 1
#pragma fastcall16 SPI_Clk_Stop                      //                 Proxy 1
#pragma fastcall16 SPI_Clk_bReadTimer                // Read  DR0       Proxy 1
#pragma fastcall16 SPI_Clk_bReadTimerSaveCV          // Read  DR0       Proxy 2
#pragma fastcall16 SPI_Clk_WritePeriod               // Write DR1       Proxy 1
#pragma fastcall16 SPI_Clk_bReadCompareValue         // Read  DR2       Proxy 1
#pragma fastcall16 SPI_Clk_WriteCompareValue         // Write DR2       Proxy 1

// The following symbols are deprecated.
// They may be omitted in future releases
//
#pragma fastcall16 bSPI_Clk_ReadCounter              // Read  DR0 "Obsolete"
#pragma fastcall16 bSPI_Clk_CaptureCounter           // Read  DR0 "Obsolete"
#pragma fastcall16 bSPI_Clk_ReadTimer                // Read  DR0 (Deprecated)
#pragma fastcall16 bSPI_Clk_ReadTimerSaveCV          // Read  DR0 (Deprecated)
#pragma fastcall16 bSPI_Clk_ReadCompareValue         // Read  DR2 (Deprecated)


//-------------------------------------------------
// Prototypes of the SPI_Clk API.
//-------------------------------------------------

extern void SPI_Clk_EnableInt(void);
extern void SPI_Clk_DisableInt(void);
extern void SPI_Clk_Start(void);
extern void SPI_Clk_Stop(void);
extern BYTE SPI_Clk_bReadTimer(void);
extern BYTE SPI_Clk_bReadTimerSaveCV(void);
extern void SPI_Clk_WritePeriod(BYTE bPeriod);
extern BYTE SPI_Clk_bReadCompareValue(void);
extern void SPI_Clk_WriteCompareValue(BYTE bCompareValue);

// The following functions are deprecated.
// They may be omitted in future releases
//
extern BYTE bSPI_Clk_ReadCompareValue(void);       // Deprecated
extern BYTE bSPI_Clk_ReadTimerSaveCV(void);        // Deprecated
extern BYTE bSPI_Clk_ReadCounter(void);            // Obsolete
extern BYTE bSPI_Clk_ReadTimer(void);              // Deprecated
extern BYTE bSPI_Clk_CaptureCounter(void);         // Obsolete


//--------------------------------------------------
// Constants for SPI_Clk API's.
//--------------------------------------------------

#define SPI_Clk_CONTROL_REG_START_BIT          ( 0x01 )
#define SPI_Clk_INT_REG_ADDR                   ( 0x0e1 )
#define SPI_Clk_INT_MASK                       ( 0x20 )


//--------------------------------------------------
// Constants for SPI_Clk user defined values
//--------------------------------------------------

#define SPI_Clk_PERIOD                         ( 0x03 )
#define SPI_Clk_COMPARE_VALUE                  ( 0x00 )


//-------------------------------------------------
// Register Addresses for SPI_Clk
//-------------------------------------------------

#pragma ioport  SPI_Clk_COUNTER_REG:    0x034              //DR0 Count register
BYTE            SPI_Clk_COUNTER_REG;
#pragma ioport  SPI_Clk_PERIOD_REG: 0x035                  //DR1 Period register
BYTE            SPI_Clk_PERIOD_REG;
#pragma ioport  SPI_Clk_COMPARE_REG:    0x036              //DR2 Compare register
BYTE            SPI_Clk_COMPARE_REG;
#pragma ioport  SPI_Clk_CONTROL_REG:    0x037              //Control register
BYTE            SPI_Clk_CONTROL_REG;
#pragma ioport  SPI_Clk_FUNC_REG:   0x134                  //Function register
BYTE            SPI_Clk_FUNC_REG;
#pragma ioport  SPI_Clk_INPUT_REG:  0x135                  //Input register
BYTE            SPI_Clk_INPUT_REG;
#pragma ioport  SPI_Clk_OUTPUT_REG: 0x136                  //Output register
BYTE            SPI_Clk_OUTPUT_REG;
#pragma ioport  SPI_Clk_INT_REG:       0x0e1               //Interrupt Mask Register
BYTE            SPI_Clk_INT_REG;


//-------------------------------------------------
// SPI_Clk Macro 'Functions'
//-------------------------------------------------

#define SPI_Clk_Start_M \
   ( SPI_Clk_CONTROL_REG |=  SPI_Clk_CONTROL_REG_START_BIT )

#define SPI_Clk_Stop_M  \
   ( SPI_Clk_CONTROL_REG &= ~SPI_Clk_CONTROL_REG_START_BIT )

#define SPI_Clk_EnableInt_M   \
   M8C_EnableIntMask(  SPI_Clk_INT_REG, SPI_Clk_INT_MASK )

#define SPI_Clk_DisableInt_M  \
   M8C_DisableIntMask( SPI_Clk_INT_REG, SPI_Clk_INT_MASK )


// end of file SPI_Clk.h
