;****************************************************************************
;
;   file:           config.inc 
;   Description:    This file contains configuration definitions for the LS DVK
;   Target:         Cypress CY7C63723/CY7C63743 Encore Chips
;   $Header:
;   Version:        1.3.0000
;
;****************************************************************************
; Copyright (2003), Cypress Semiconductor Corporation
; This software is owned by Cypress Semiconductor Corporation (Cypress) and  is
; protected by United States copyright laws and international treaty provisions.
; Cypress hereby grants to Licensee a personal, non-exclusive, non-transferable
; license to copy, use, modify, create derivative works of, and compile the
; Cypress Source Code and derivative works for the sole purpose of creating
; custom software in support of Licensee product ("Licensee Product") to be used
; only in conjunction with a Cypress integrated circuit. Any reproduction,
; modification, translation, compilation, or representation of this software
; except as specified above is prohibited without the express written permission
; of Cypress.
; Disclaimer: Cypress makes no warranty of any kind, express or implied, with
; regard to this material, including, but not limited to, the implied warranties
; of merchantability and fitness for a particular purpose. Cypress reserves the
; right to make changes without further notice to the materials described herein.
; Cypress does not assume any liability arising out of the application or use of
; any product or circuit described herein. Cypress products described herein are
; not authorized for use as components in life-support devices.
; This software is protected by and subject to worldwide patent coverage,
; including U.S. and foreign patents. Use may be limited by and subject to the
; Cypress Software License Agreement.
;
;****************************************************************************

;***** DEVICE TYPE *****
DEFINE              DEVICE_KBM_COMBO

;***** DATA RATE *****
DEFINE              DATA_RATE_64   

;***** BIND PROCEDURE *****
DEFINE              BIND_AUTO
DEFINE              TWO_WAY_DATA
DEFINE              TWO_WAY_PROTOCOL
;DEFINE              BIND_NO_HOP    ; FOR DEBUG ONLY  
;DEFINE              PING_NO_HOP    ; FOR DEBUG ONLY

DEFINE              PDC_9075
;DEFINE              PDC_9168

; Allows co-location of multiple LS systems
DEFAULT_CHECKSUM_SEED:  equ 00h


;DEFINE CHECKSUM_ALL_PACKETS
DEFINE              PROTOCOL_1_1
;DEFINE              ENCRYPT_DATA_A
DEFINE              DYNAMIC_PA_SUPPORT

;***** RADIO DEFINES *****
PA_BIAS:            equ 07h     ; radio power amp bias
BIND_PA_BIAS:       equ 04h


;***** DEVICE SPECIFIC CONFIGURATIONS *****
DEFINE              REMOTE_WAKEUP_SUPPORT
DEVICE_TYPE_A:      equ 02h
DEVICE_TYPE_B:      equ 03h
NUM_EP1_BYTES:      equ 08h     ; keyboard
NUM_EP2_BYTES:      equ 08h     ; mouse
DEFINE              COMBO_DEVICE
DEFINE              MFG_TEST
DEFINE              MFG_USE_BUTTON
