#ifndef _EMC_TESTER_H_
#define _EMC_TESTER_H_

#include "cypdef.h"
//! Idle mode for emc_tester
#define EMC_TESTER_IDLE       0x00
//! Transmit carrier mode for emc_tester
#define EMC_TESTER_CARRIER    0x01
//! Transmit data mode for emc_tester
#define EMC_TESTER_DATA       0x02
//! Receive mode for emc_tester
#define EMC_TESTER_RECEIVE    0x03
//! Tranmit packet data mode for emc_tester
#define EMC_TESTER_PKT_DATA   0x04

//! Data rate of 16kbps
#define DATA_RATE_16	16
//! Data rate of 32kbps
#define DATA_RATE_32	32
//! Data rate of 64kbps
#define DATA_RATE_64    64

//! Bottom channel (0) reference
#define CHANNEL_BOTTOM    0
//! Middle channel (38) reference
#define CHANNEL_MIDDLE    38
//! Top channel (77) reference
#define CHANNEL_TOP       77

void start_transmit_carrier(void);
void stop_transmit_carrier(void);
void start_transmit_data(void);
void start_transmit_pkt_data(void);
void stop_transmit_data(void);
void start_receive(void);
void stop_receive(void);

UINT8 stop_test(void);    
UINT8 restart_test(void);
//void auto_run_test(void);
void  packet_test(void);
UINT8 reset_test(void);
UINT8 increment_test(void);

UINT8 reset_pn_code(void);
UINT8 increment_pn_code(void);
UINT8 decrement_pn_code(void);
UINT8 reset_channel(void);
UINT8 increment_channel(void);
UINT8 decrement_channel(void);
UINT8 reset_data_rate(void);
UINT8 increment_data_rate(void);
UINT8 decrement_data_rate(void);
UINT8 increment_pa_bias(void);
UINT8 decrement_pa_bias(void);
#endif    // _EMC_TESTER_H_
