//--------------------------------------------------------------------------
//! \file
//!
//!  This file contains DVK common ISR code types and macros
//!
//--------------------------------------------------------------------------
// $Archive: /WirelessUSB/LS/Firmware/LS DVK/PSoC/Common/isr.h $
// $Modtime: 2/12/04 12:33p $
// $Revision: 1.3 $
//--------------------------------------------------------------------------
//
// Copyright 2003, Cypress Semiconductor Corporation.
//
// This software is owned by Cypress Semiconductor Corporation (Cypress)
// and is protected by and subject to worldwide patent protection (United
// States and foreign), United States copyright laws and international 
// treaty provisions. Cypress hereby grants to licensee a personal, 
// non-exclusive, non-transferable license to copy, use, modify, create 
// derivative works of, and compile the Cypress Source Code and derivative 
// works for the sole purpose of creating custom software in support of 
// licensee product to be used only in conjunction with a Cypress integrated 
// circuit as specified in the applicable agreement. Any reproduction, 
// modification, translation, compilation, or representation of this 
// software except as specified above is prohibited without the express 
// written permission of Cypress.
//
// Disclaimer: CYPRESS MAKES NO WARRANTY OF ANY KIND,EXPRESS OR IMPLIED, 
// WITH REGARD TO THIS MATERIAL, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
// Cypress reserves the right to make changes without further notice to the
// materials described herein. Cypress does not assume any liability arising
// out of the application or use of any product or circuit described herein.
// Cypress does not authorize its products for use as critical components in
// life-support systems where a malfunction or failure may reasonably be
// expected to result in significant injury to the user. The inclusion of
// Cypress product in a life-support systems application implies that the
// manufacturer assumes all risk of such use and in doing so indemnifies
// Cypress against all charges.
//
// Use may be limited by and subject to the applicable Cypress software
// license agreement.
//
//--------------------------------------------------------------------------

#ifndef _ISR_H_
#define _ISR_H_

//--------------------------------------
// API Definitions and Types
//--------------------------------------

//! Used for enabling and disabling the ISR.  It is also used to check the ISR status 
//! of the port
typedef enum
{
    INT_DUMMY1  = 0x01,
    INT_RADIO   = 0x02,
    INT_DUMMY2  = 0x04
    
} DVK_ISR;



//--------------------------------------
// API Function Declarations
//--------------------------------------

#pragma interrupt_handler isr_gpio

extern void isr_gpio(void);
extern void isr_init(void);
extern void isr_enable(DVK_ISR);
extern void isr_disable(DVK_ISR);
extern BOOL isr_is_enabled(DVK_ISR);

#endif   // #include


