;;*****************************************************************************
;;*****************************************************************************
;;  FILENAME: SPI_Clk.inc
;;   Version: 2.4, Updated on 2004/10/27 at 18:26:56
;;  Generated by PSoC Designer ver 4.2  b1013 : 02 September, 2004
;;
;;  DESCRIPTION: Assembler declarations for the Timer8 user module interface
;;               for the 22/24/27/29xxx PSoC family of devices
;;-----------------------------------------------------------------------------
;;  Copyright (c) Cypress MicroSystems 2000-2004. All Rights Reserved.
;;*****************************************************************************
;;*****************************************************************************

include "m8c.inc"


;--------------------------------------------------
; Constants for SPI_Clk API's.
;--------------------------------------------------

SPI_Clk_CONTROL_REG_START_BIT:             equ 0x01    ; Control register start bit
SPI_Clk_INT_REG:                           equ 0x0e1
SPI_Clk_INT_MASK:                          equ 0x20


;--------------------------------------------------
; Constants for SPI_Clk user defined values
;--------------------------------------------------

SPI_Clk_PERIOD:                            equ 0x03
SPI_Clk_COMPARE_VALUE:                     equ 0x00


;--------------------------------------------------
; Register Address Constants for SPI_Clk
;--------------------------------------------------

SPI_Clk_COUNTER_REG:                   equ 0x34   ; DR0 Counter register
SPI_Clk_PERIOD_REG:                    equ 0x35   ; DR1 Period register
SPI_Clk_COMPARE_REG:                   equ 0x36   ; DR2 CompareValue register
SPI_Clk_CONTROL_REG:                   equ 0x37   ; Control register
SPI_Clk_FUNC_REG:                      equ 0x34   ; Function register
SPI_Clk_INPUT_REG:                     equ 0x35   ; Input register
SPI_Clk_OUTPUT_REG:                    equ 0x36   ; Output register


;--------------------------------------------------
; SPI_Clk Macro 'Functions'
;--------------------------------------------------

   macro SPI_Clk_Start_M
   or    reg[SPI_Clk_CONTROL_REG],  SPI_Clk_CONTROL_REG_START_BIT
   endm

   macro SPI_Clk_Stop_M
   and   reg[SPI_Clk_CONTROL_REG], ~SPI_Clk_CONTROL_REG_START_BIT
   endm

   macro SPI_Clk_EnableInt_M
   M8C_EnableIntMask SPI_Clk_INT_REG, SPI_Clk_INT_MASK
   endm

   macro SPI_Clk_DisableInt_M
   M8C_DisableIntMask SPI_Clk_INT_REG, SPI_Clk_INT_MASK
   endm


; end of file SPI_Clk.inc
