//*****************************************************************************
//*****************************************************************************
//  FILENAME: RX8_1.h
//   Version: 2.2, Updated on 2003/11/18 at 15:01:51
//  Generated by PSoC Designer ver 4.1 b931 : 21 January, 2004
//
//  DESCRIPTION:  RX8 User Module C Language interface file for the
//                22/24/25/26/27xxx PSoC family of devices.
//-----------------------------------------------------------------------------
//      Copyright (c) Cypress MicroSystems 2000-2003. All Rights Reserved.
//*****************************************************************************
//*****************************************************************************


// include the global header file
#include <m8c.h>

// Create pragmas to support proper argument and return value passing
#pragma fastcall  RX8_1_EnableInt
#pragma fastcall  RX8_1_DisableInt
#pragma fastcall  RX8_1_Start
#pragma fastcall  RX8_1_Stop
#pragma fastcall  RX8_1_bReadRxData
#pragma fastcall  RX8_1_bReadRxStatus

//-------------------------------------------------
// Prototypes of the RX8_1 API.
//-------------------------------------------------
extern void  RX8_1_EnableInt(void);
extern void  RX8_1_DisableInt(void);
extern void  RX8_1_Start(BYTE bParity);
extern void  RX8_1_Stop(void);
extern BYTE  RX8_1_bReadRxData(void);
extern BYTE  RX8_1_bReadRxStatus(void);

// Old function call names, do not use.
// These names will be removed in a future release.
#pragma fastcall bRX8_1_ReadRxData
#pragma fastcall bRX8_1_ReadRxStatus
extern BYTE bRX8_1_ReadRxData(void);
extern BYTE bRX8_1_ReadRxStatus(void);

//-------------------------------------------------
// Constants for RX8_1 API's.
//-------------------------------------------------
//------------------------------------
// Receiver Parity masks
//------------------------------------
#define  RX8_1_PARITY_NONE         0x00
#define  RX8_1_PARITY_EVEN         0x02
#define  RX8_1_PARITY_ODD          0x06

//------------------------------------
//  Receiver Status Register masks
//------------------------------------
#define  RX8_1_RX_ACTIVE           0x10
#define  RX8_1_RX_COMPLETE         0x08
#define  RX8_1_RX_PARITY_ERROR     0x80
#define  RX8_1_RX_OVERRUN_ERROR    0x40
#define  RX8_1_RX_FRAMING_ERROR    0x20
#define  RX8_1_RX_NO_ERROR         0xE0

// Old defines, will be removed in future release
#define  RX8_PARITY_NONE         0x00
#define  RX8_PARITY_EVEN         0x02
#define  RX8_PARITY_ODD          0x06
#define  RX8_RX_ACTIVE           0x10
#define  RX8_RX_COMPLETE         0x08
#define  RX8_RX_PARITY_ERROR     0x80
#define  RX8_RX_OVERRUN_ERROR    0x40
#define  RX8_RX_FRAMING_ERROR    0x20
#define  RX8_RX_NO_ERROR         0xE0

//-------------------------------------------------
// Register Addresses for RX8_1
//-------------------------------------------------
#pragma ioport  RX8_1_CONTROL_REG:  0x037                  // Control register
BYTE            RX8_1_CONTROL_REG;
#pragma ioport  RX8_1_RX_SHIFT_REG: 0x034                  // RX Shift Register register
BYTE            RX8_1_RX_SHIFT_REG;
#pragma ioport  RX8_1_RX_BUFFER_REG:    0x036              // RX Buffer Register
BYTE            RX8_1_RX_BUFFER_REG;
#pragma ioport  RX8_1_FUNC_REG: 0x134                      // Function register
BYTE            RX8_1_FUNC_REG;
#pragma ioport  RX8_1_INPUT_REG:    0x135                  // Input register
BYTE            RX8_1_INPUT_REG;
#pragma ioport  RX8_1_OUTPUT_REG:   0x136                  // Output register
BYTE            RX8_1_OUTPUT_REG;

// end of file RX8_1.h
