//--------------------------------------------------------------------------
//!  \file
//!
//!  This file contains DVK common SPI API code types and macros.
//!
//--------------------------------------------------------------------------
// $Archive: /WirelessUSB/LS/Firmware/LS DVK/PSoC/Common/spi.h $
// $Modtime: 2/12/04 12:33p $
// $Revision: 1.4 $
//--------------------------------------------------------------------------
//
// Copyright 2003, Cypress Semiconductor Corporation.
//
// This software is owned by Cypress Semiconductor Corporation (Cypress)
// and is protected by and subject to worldwide patent protection (United
// States and foreign), United States copyright laws and international 
// treaty provisions. Cypress hereby grants to licensee a personal, 
// non-exclusive, non-transferable license to copy, use, modify, create 
// derivative works of, and compile the Cypress Source Code and derivative 
// works for the sole purpose of creating custom software in support of 
// licensee product to be used only in conjunction with a Cypress integrated 
// circuit as specified in the applicable agreement. Any reproduction, 
// modification, translation, compilation, or representation of this 
// software except as specified above is prohibited without the express 
// written permission of Cypress.
//
// Disclaimer: CYPRESS MAKES NO WARRANTY OF ANY KIND,EXPRESS OR IMPLIED, 
// WITH REGARD TO THIS MATERIAL, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
// Cypress reserves the right to make changes without further notice to the
// materials described herein. Cypress does not assume any liability arising
// out of the application or use of any product or circuit described herein.
// Cypress does not authorize its products for use as critical components in
// life-support systems where a malfunction or failure may reasonably be
// expected to result in significant injury to the user. The inclusion of
// Cypress product in a life-support systems application implies that the
// manufacturer assumes all risk of such use and in doing so indemnifies
// Cypress against all charges.
//
// Use may be limited by and subject to the applicable Cypress software
// license agreement.
//
//--------------------------------------------------------------------------

#include "cypdef.h"

#ifndef _SPI_H_
#define _SPI_H_

#ifndef SPIM_MODE_0
//! MODE 0 - Leading edge latches data - pos clock
#define SPIM_MODE_0			SPIM_1_SPIM_MODE_0
#endif

#ifndef SPIM_MSB_FIRST
//! MSB bit transmitted/received first
#define SPIM_MSB_FIRST		SPIM_1_SPIM_MSB_FIRST
#endif

#ifndef SPIM_SPI_COMPLETE
//! SPI Tx/Rx cycle has completed
#define SPIM_SPI_COMPLETE	SPIM_1_SPIM_SPI_COMPLETE
#endif

//! Mask for the 6 bit address
#define SPI_ADDRESS_MASK	0x3F
//! Bit representing an SPI write
#define bSPI_WRITE 		0x80


void spi_radio_on(void);
void spi_radio_reset(void);
void spi_radio_put(UINT8 address, UINT8 data);
UINT8 spi_radio_get(UINT8 address);

#endif // _SPI_H_

