//*****************************************************************************
//*****************************************************************************
//  FILENAME: Tick.h
//   Version: 2.4, Updated on 2004/10/27 at 18:26:56
//  Generated by PSoC Designer ver 4.2  b1013 : 02 September, 2004
//
//  DESCRIPTION: Timer8 User Module C Language interface file
//               for the 22/24/27/29xxx PSoC family of devices
//-----------------------------------------------------------------------------
//  Copyright (c) Cypress MicroSystems 2000-2004. All Rights Reserved.
//*****************************************************************************
//*****************************************************************************

#include <m8c.h>

#pragma fastcall16 Tick_EnableInt                 //                 Proxy 1
#pragma fastcall16 Tick_DisableInt                //                 Proxy 1
#pragma fastcall16 Tick_Start                     //                 Proxy 1
#pragma fastcall16 Tick_Stop                      //                 Proxy 1
#pragma fastcall16 Tick_bReadTimer                // Read  DR0       Proxy 1
#pragma fastcall16 Tick_bReadTimerSaveCV          // Read  DR0       Proxy 2
#pragma fastcall16 Tick_WritePeriod               // Write DR1       Proxy 1
#pragma fastcall16 Tick_bReadCompareValue         // Read  DR2       Proxy 1
#pragma fastcall16 Tick_WriteCompareValue         // Write DR2       Proxy 1

// The following symbols are deprecated.
// They may be omitted in future releases
//
#pragma fastcall16 bTick_ReadCounter              // Read  DR0 "Obsolete"
#pragma fastcall16 bTick_CaptureCounter           // Read  DR0 "Obsolete"
#pragma fastcall16 bTick_ReadTimer                // Read  DR0 (Deprecated)
#pragma fastcall16 bTick_ReadTimerSaveCV          // Read  DR0 (Deprecated)
#pragma fastcall16 bTick_ReadCompareValue         // Read  DR2 (Deprecated)


//-------------------------------------------------
// Prototypes of the Tick API.
//-------------------------------------------------

extern void Tick_EnableInt(void);
extern void Tick_DisableInt(void);
extern void Tick_Start(void);
extern void Tick_Stop(void);
extern BYTE Tick_bReadTimer(void);
extern BYTE Tick_bReadTimerSaveCV(void);
extern void Tick_WritePeriod(BYTE bPeriod);
extern BYTE Tick_bReadCompareValue(void);
extern void Tick_WriteCompareValue(BYTE bCompareValue);

// The following functions are deprecated.
// They may be omitted in future releases
//
extern BYTE bTick_ReadCompareValue(void);       // Deprecated
extern BYTE bTick_ReadTimerSaveCV(void);        // Deprecated
extern BYTE bTick_ReadCounter(void);            // Obsolete
extern BYTE bTick_ReadTimer(void);              // Deprecated
extern BYTE bTick_CaptureCounter(void);         // Obsolete


//--------------------------------------------------
// Constants for Tick API's.
//--------------------------------------------------

#define Tick_CONTROL_REG_START_BIT             ( 0x01 )
#define Tick_INT_REG_ADDR                      ( 0x0e1 )
#define Tick_INT_MASK                          ( 0x08 )


//--------------------------------------------------
// Constants for Tick user defined values
//--------------------------------------------------

#define Tick_PERIOD                            ( 0x20 )
#define Tick_COMPARE_VALUE                     ( 0x00 )


//-------------------------------------------------
// Register Addresses for Tick
//-------------------------------------------------

#pragma ioport  Tick_COUNTER_REG:   0x02c                  //DR0 Count register
BYTE            Tick_COUNTER_REG;
#pragma ioport  Tick_PERIOD_REG:    0x02d                  //DR1 Period register
BYTE            Tick_PERIOD_REG;
#pragma ioport  Tick_COMPARE_REG:   0x02e                  //DR2 Compare register
BYTE            Tick_COMPARE_REG;
#pragma ioport  Tick_CONTROL_REG:   0x02f                  //Control register
BYTE            Tick_CONTROL_REG;
#pragma ioport  Tick_FUNC_REG:  0x12c                      //Function register
BYTE            Tick_FUNC_REG;
#pragma ioport  Tick_INPUT_REG: 0x12d                      //Input register
BYTE            Tick_INPUT_REG;
#pragma ioport  Tick_OUTPUT_REG:    0x12e                  //Output register
BYTE            Tick_OUTPUT_REG;
#pragma ioport  Tick_INT_REG:       0x0e1                  //Interrupt Mask Register
BYTE            Tick_INT_REG;


//-------------------------------------------------
// Tick Macro 'Functions'
//-------------------------------------------------

#define Tick_Start_M \
   ( Tick_CONTROL_REG |=  Tick_CONTROL_REG_START_BIT )

#define Tick_Stop_M  \
   ( Tick_CONTROL_REG &= ~Tick_CONTROL_REG_START_BIT )

#define Tick_EnableInt_M   \
   M8C_EnableIntMask(  Tick_INT_REG, Tick_INT_MASK )

#define Tick_DisableInt_M  \
   M8C_DisableIntMask( Tick_INT_REG, Tick_INT_MASK )


// end of file Tick.h
