//--------------------------------------------------------------------------
//! \file
//!
//! Configure All Global Compile Options
//!
//! These items are usually set in the sources files, but can be over-ridden
//!  here by using 'define' or 'undefine'.
//!
//--------------------------------------------------------------------------
// $Archive: /WirelessUSB/LS/Firmware/LS DVK/PSoC/DVK RS232 Master/ls_config.h $
// $Modtime: 3/04/04 2:41p $
// $Revision: 1.3 $
//--------------------------------------------------------------------------
//
// Copyright 2003-2004, Cypress Semiconductor Corporation.
//
// This software is owned by Cypress Semiconductor Corporation (Cypress)
// and is protected by and subject to worldwide patent protection (United
// States and foreign), United States copyright laws and international 
// treaty provisions. Cypress hereby grants to licensee a personal, 
// non-exclusive, non-transferable license to copy, use, modify, create 
// derivative works of, and compile the Cypress Source Code and derivative 
// works for the sole purpose of creating custom software in support of 
// licensee product to be used only in conjunction with a Cypress integrated 
// circuit as specified in the applicable agreement. Any reproduction, 
// modification, translation, compilation, or representation of this 
// software except as specified above is prohibited without the express 
// written permission of Cypress.
//
// Disclaimer: CYPRESS MAKES NO WARRANTY OF ANY KIND,EXPRESS OR IMPLIED, 
// WITH REGARD TO THIS MATERIAL, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
// Cypress reserves the right to make changes without further notice to the
// materials described herein. Cypress does not assume any liability arising
// out of the application or use of any product or circuit described herein.
// Cypress does not authorize its products for use as critical components in
// life-support systems where a malfunction or failure may reasonably be
// expected to result in significant injury to the user. The inclusion of
// Cypress product in a life-support systems application implies that the
// manufacturer assumes all risk of such use and in doing so indemnifies
// Cypress against all charges.
//
// Use may be limited by and subject to the applicable Cypress software
// license agreement.
//
//--------------------------------------------------------------------------

#ifndef _LS_CONFIG_H_
#define _LS_CONFIG_H_



//--------------------------------------
// Included files
//--------------------------------------
#include "cypdef.h"
#include "psocgpioint.h"
#include "pdc9075.h"

//--------------------------------------
// API Definitions and Types
//--------------------------------------

// RADIO PARAMETERS
//! Data rate 64 kbps
#define DATA_RATE_64



// API Macro's

//! Macro for the timer_delay_10_usec routine
#define TIMER_DELAY_10_USEC()                 timer_delay_10_usec()
//! Macro for the timer_delay_50_usec routine
#define TIMER_DELAY_50_USEC()                 timer_delay_50_usec()
//! Macro for the timer_delay_msec routine
#define TIMER_DELAY_MSEC(cnt)                 timer_delay_msec(cnt)
//! Macro for the timer_delay_incremental routine
#define TIMER_DELAY_INCREMENTAL(base, incr)   timer_delay_incremental(base, incr)
//! Macro for the timer_time_elapsed routine
#define TIMER_IS_TIME_ELASPSED(base, curr)    timer_time_elasped(base, incr)
//! Macro for the timer_get_time_stamp routine
#define TIMER_GET_TIME_STAMP()                timer_get_time_stamp()

#endif // _LS_CONFIG_H_
